//========================================================
// File		: DeviceCommu.c
// Author	: wzh
// Version	: V1.0
// Date		: 21.11.01
//========================================================
#define GLOBAL_DeviceCommu		//GLOBALS, ʾеȫֱڱļж
//========================================================
// Section: Included Files
//========================================================
#include "../main.h"
#include "../Library/Device/Include/ML51.h"
//========================================================
// Section: Macro Declarations
//========================================================

//========================================================
#if		1
//========================================================
// Function		: 
// Function API	: 
//========================================================
void Uart_Send_Read_Ack(void)
{
	//========================================================
	unsigned	char	i,temp;
	//========================================================
	temp = ucDeviceCommu_Buffer[DEVICE_COMMU_CMD];
	for(i=DEVICE_COMMU_PARA0;i<=DEVICE_COMMU_PARA3;i++)
		temp ^= ucDeviceCommu_Buffer[i];
	//========================================================
	ucDeviceCommu_Buffer[DEVICE_COMMU_CHECKSUM] = temp;
	//========================================================
	ucDeviceCommu_Length_Count = 0;
	ucDeviceCommu_Data_Length  = DEVICE_UART_LEN_FRAME;
	//========================================================
	DEVCOM_API_Commu_Idle  = 0;
	ucDeviceCommu_Event = DEVICE_COMMU_EVENT_SEND_LOAD;
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
// Function		: 
// Function API	: 
//========================================================
void DeviceCommu_Handler(void)
{
	//========================================================
	unsigned	char	i,temp;
	//========================================================
	switch( ucDeviceCommu_Event )
	{
		//========================================================
		case DEVICE_COMMU_EVENT_RECEIVE:
			//========================================================
			DEVCOM_API_Receive_Interrupt_ClrFlag;	// Clear RI(Receive Interrupt)
			DEVCOM_API_Interrupt_Enable; 			// Enable UART0 interrupt
			//========================================================
			ucDeviceCommu_Event++;
			ucDeviceCommu_Data_Length = 0;
			ucDeviceCommu_TimeCount = DEVCOM_API_TimeBase_1ms;
			//========================================================
			break;
			//========================================================
		case DEVICE_COMMU_EVENT_RECEIVE+1:
			//========================================================
			if( (unsigned char)(DEVCOM_API_TimeBase_1ms-ucDeviceCommu_TimeCount)>=20 )
			{
				//========================================================
				DEVCOM_API_Commu_Idle = 1;
				ucDeviceCommu_Data_Length = 0;
				ucDeviceCommu_TimeCount = DEVCOM_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case DEVICE_COMMU_EVENT_RECEIVE+2:
			//========================================================
			temp = ucDeviceCommu_Buffer[ucDeviceCommu_Data_Length-2];	// Checksum
			for(i=1;i<=(ucDeviceCommu_Data_Length-3);i++)
				temp ^= ucDeviceCommu_Buffer[i];
			//========================================================
			if( temp==0 )
				ucDeviceCommu_Event++;
			else
				ucDeviceCommu_Event = DEVICE_COMMU_EVENT_RECEIVE;		// Checksum error
			//========================================================
			break;
			//========================================================
		case DEVICE_COMMU_EVENT_RECEIVE+3:
			//========================================================
			if( ucDeviceCommu_Buffer[DEVICE_COMMU_CMD]==CMD_MESSAGE )
			{	// Smoke Message
				//========================================================
				ucDeviceCommu_Buffer[DEVICE_COMMU_PARA0] = (DEVCOM_API_Type_Value*10)>>8;
				ucDeviceCommu_Buffer[DEVICE_COMMU_PARA1] = DEVCOM_API_Type_Value*10;
				ucDeviceCommu_Buffer[DEVICE_COMMU_PARA2] = 0x00;
				ucDeviceCommu_Buffer[DEVICE_COMMU_PARA3] = DEVCOM_API_Shade_Value;
				//========================================================
			}
			else if( ucDeviceCommu_Buffer[DEVICE_COMMU_CMD]==CMD_SOFTWARE_VERSION )
			{	// Software Version	汾
				//========================================================
				for(i=0;i<4;i++)
					ucDeviceCommu_Buffer[DEVICE_COMMU_PARA0+i] = DEVCOM_API_SoftwareVersion[i];
				//========================================================
			}
			else if( ucDeviceCommu_Buffer[DEVICE_COMMU_CMD]==CMD_HARDWARE_VERSION )
			{	// Hardware Version	Ӳ汾
				//========================================================
				for(i=0;i<4;i++)
					ucDeviceCommu_Buffer[DEVICE_COMMU_PARA0+i] = DEVCOM_API_HardwareVersion[i];
				//========================================================
			}
			//========================================================
			Uart_Send_Read_Ack();
			//========================================================
			break;
			//========================================================
		case DEVICE_COMMU_EVENT_SEND_LOAD:
			//========================================================
			if( ucDeviceCommu_Data_Length )
			{
				//========================================================
				DEVCOM_API_Send_Interrupt_ClrFlag; 	// Clear TI(Transmit Interrupt).
				DEVCOM_API_Data_Buffer = ucDeviceCommu_Buffer[ucDeviceCommu_Length_Count++];
				//========================================================
				ucDeviceCommu_Data_Length--;
				ucDeviceCommu_Event++;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case DEVICE_COMMU_EVENT_SEND_LOAD+1:
			//========================================================
			if( DEVCOM_API_Send_Interrupt_Flag )
			{
				//========================================================
				DEVCOM_API_Send_Interrupt_ClrFlag; 	// Clear TI(Transmit Interrupt).
				//========================================================
				ucDeviceCommu_Event--;
				//========================================================
				if( ucDeviceCommu_Data_Length==0 )
					ucDeviceCommu_Event = DEVICE_COMMU_EVENT_RECEIVE;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		default:
			//========================================================
			ucDeviceCommu_Event = DEVICE_COMMU_EVENT_RECEIVE;
			//========================================================
			break;
			//========================================================
		//========================================================
	}
	//========================================================
}
//========================================================
// Function		: UART0 interrupt subroutine.
// Function API	: 
//========================================================
void UART0_ISR (void) interrupt 4		// UART1 interrupt	0023H	4
{
	//========================================================
	if( DEVCOM_API_Receive_Interrupt_Flag )
	{
		//========================================================
		DEVCOM_API_Receive_Interrupt_ClrFlag;	// Clear RI(Receive Interrupt).
		ucDeviceCommu_Buffer[ucDeviceCommu_Data_Length++] = DEVCOM_API_Data_Buffer;
		//========================================================
		DEVCOM_API_Commu_Idle = 0;
		ucDeviceCommu_TimeCount = DEVCOM_API_TimeBase_1ms;
		//========================================================
		if( ucDeviceCommu_Buffer[DEVICE_COMMU_HEADER]!=MODBUS_HEADER )
		{
			//========================================================
			ucDeviceCommu_Data_Length = 0;
			//========================================================
		}
		else if( ucDeviceCommu_Data_Length==DEVICE_UART_LEN_FRAME )
		{
			//========================================================
			ucDeviceCommu_Event++;
			//========================================================
			DEVCOM_API_Interrupt_Disabled;		// Disabled UART0 interrupt
			//========================================================
		}
		//========================================================
	}
	//========================================================
}
//========================================================
#endif
//========================================================
// Function		: 
// Function API	: 
//========================================================
