//==============================================================
// File		: DeviceCommu.h
// Author	: wzh
// Version	: V1.0
// Date		: 21.11.01
//==============================================================

//Define to prevent recursive inclusion=========================
#ifndef	DeviceCommu_H
#define	DeviceCommu_H

//==============================================================
// Section: Included Files
//==============================================================

//==============================================================
#ifdef GLOBAL_DeviceCommu
    #define EXT_DeviceCommu
#else
    #define EXT_DeviceCommu extern
#endif
//==============================================================
// Section: Exported Constants
//==============================================================
#define	DEVICE_COMMU_HEADER				0
#define	DEVICE_COMMU_CMD				1
#define	DEVICE_COMMU_PARA0				2
#define	DEVICE_COMMU_PARA1				3
#define	DEVICE_COMMU_PARA2				4
#define	DEVICE_COMMU_PARA3				5
#define	DEVICE_COMMU_CHECKSUM			6
//==Modbus======================================================
#define	MODBUS_HEADER					0x55
#define	MODBUS_END						0xED
//==Cmd=========================================================
#define	CMD_HARDWARE_VERSION			0x01	// Hardware Version	Ӳ汾
#define	CMD_SOFTWARE_VERSION			0x02	// Software Version	汾
#define	CMD_MESSAGE						0x05	// Smoke Message
//==============================================================
#define	DEVICE_COMMU_EVENT_RECEIVE		0		// Receive	Rx
#define	DEVICE_COMMU_EVENT_SEND_LOAD	10		// Tx
//==============================================================
// Section: Exported Variables
//==============================================================
#define	DEVICE_UART_LEN_FRAME			8
#define DEVICE_UART_LEN					20
EXT_DeviceCommu unsigned char			ucDeviceCommu_Data_Length;
EXT_DeviceCommu unsigned char			ucDeviceCommu_Length_Count;
EXT_DeviceCommu unsigned char			ucDeviceCommu_Buffer[DEVICE_UART_LEN];
//==============================================================
EXT_DeviceCommu unsigned		char	data	ucDeviceCommu_Event;				// Event
EXT_DeviceCommu volatile	unsigned	char	data	ucDeviceCommu_TimeCount;	// TimeCount
//==============================================================
// Section: Exported Interface
//==============================================================
	//==============================================================
	// DEVCOM = Device Communication 
	// API = Interface
	// DEVCOM_API = Device Communication Interface
	//==============================================================
	//==Device Communication Interface Output=======================
	//==============================================================
	#define	DEVCOM_API_Init							(ucDeviceCommu_Event = DEVICE_COMMU_EVENT_RECEIVE)
	//==============================================================
	//==Device Communication Interface Input========================
	//==============================================================
	#define DEVCOM_API_Commu_Idle					(bDevice_Commu_Idle)
	#define DEVCOM_API_TimeBase_1ms					(ucTimeCount_Base)
	//==============================================================
	#define DEVCOM_API_Type_Value					(Type_Value)
	#define DEVCOM_API_Shade_Value					(Shade_Value)
	#define DEVCOM_API_SoftwareVersion				(SoftwareVersion)
	#define DEVCOM_API_HardwareVersion				(HardwareVersion)
	//==============================================================
	#define DEVCOM_API_Data_Buffer					(SBUF) 				// ݻ
	#define DEVCOM_API_Interrupt_Enable				(IE |= SET_BIT4)	// Enable UART0 interrupt
	#define DEVCOM_API_Interrupt_Disabled			(IE &= CLR_BIT4)	// Disabled UART0 interrupt
	#define DEVCOM_API_Receive_Interrupt_Flag		(RI)				// ж״̬־λ
	#define DEVCOM_API_Receive_Interrupt_ClrFlag 	(RI = 0) 			// ж״̬־λClr
	#define DEVCOM_API_Send_Interrupt_Flag			(TI)				// ж״̬־λ
	#define DEVCOM_API_Send_Interrupt_ClrFlag		(TI = 0)			// ж״̬־λClr
//==============================================================
// Section: Exported Functions
//==============================================================
void DeviceCommu_Handler(void);
//==============================================================
// Section: End Of file
//==============================================================
#endif
//==============================================================
