//========================================================
// File		: SmokeMode.c
// Author	: wzh
// Version	: V1.0
// Date		: 21.11.01
//========================================================
#define GLOBAL_SmokeMode		//GLOBALS, ʾеȫֱڱļж
//========================================================
// Section: Included Files
//========================================================
#include "../main.h"
#include "../Library/Device/Include/ML51.h"
//========================================================
// Section: Macro Declarations
//========================================================

//========================================================
#if		1
//========================================================
// Function		: 
// Function API	: 
//========================================================
void Device_Memset(unsigned char *s,int c,unsigned int	n)
{
	//========================================================
	unsigned char *ptr = s;
	while(n--)
		*ptr++ = c;
	//========================================================
}
//========================================================
// Function 	: 
// Function API : 
//========================================================
void Read_HTK5020_Message(unsigned	char	Length,unsigned char Data)
{
	//========================================================
	HTK5020_Message = Data;
	//========================================================
	if( bType_Switch )
	{
		//========================================================
		Type_Value = ucSmoke_Buffer[Length++];
		//========================================================
	}
	if( bShade_Switch )
	{
		//========================================================
		Shade_Value = ucSmoke_Buffer[Length++];
		//========================================================
	}
	if( bIr_Switch )
	{
		//========================================================
		Ir_Value = (ucSmoke_Buffer[Length]<<8)+ucSmoke_Buffer[Length+1];
		Length += 2;
		//========================================================
	}
	if( bBlue_Switch )
	{
		//========================================================
		Blue_Value = (ucSmoke_Buffer[Length]<<8)+ucSmoke_Buffer[Length+1];
		Length += 2;
		//========================================================
	}
	if( bRed_Switch )
	{
		//========================================================
		Red_Value = (ucSmoke_Buffer[Length]<<8)+ucSmoke_Buffer[Length+1];
		Length += 2;
		//========================================================
	}
	if( bTemp_Switch )
	{
		//========================================================
		Temp_Value = (ucSmoke_Buffer[Length]<<8)+ucSmoke_Buffer[Length+1];
		//========================================================
	}
	//========================================================
}
//========================================================
// Function 	: 
// Function API : 
//========================================================
void Uart_TLVC_Send_Read_Ack(void)
{
	//========================================================
	unsigned	char	i,temp;
	//========================================================
	temp = ucSmoke_Buffer[FRAME_TAG]^ucSmoke_Buffer[FRAME_LENGTH];
	for(i=0;i<ucSmoke_Buffer[FRAME_LENGTH];i++)
		temp ^= ucSmoke_Buffer[FRAME_MEMBER+i];
	//========================================================
	ucSmoke_Buffer[FRAME_CHECKSUM] = temp;
	//========================================================
	ucSmoke_Length_Count = 0;
	ucSmoke_Data_Length = ucSmoke_Buffer[FRAME_LENGTH]+FRAME_VALUE;
	//========================================================
	bSmoke_Commu_Idle = 0;
	ucSmoke_Event = SMOKE_EVENT_SEND_LOAD;
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
code	unsigned	char	Smoke_Mode_Init[] = 
{
	//========================================================
	0x84,	0xFF,	0xFF,				// ģָ_мĴֵλ
	0x84,	0x00,	INIT_REGISTER_0,	// WriteƼĴ_0ֵ
	0x84,	0x01,	INIT_REGISTER_1,	// WriteƼĴ_1ֵ
	//========================================================
	0xC5,	0x00,	0x00,				// Read汾
	0xC5,	0x01,	0x00,				// ReadӲ汾
	0xC5,	0x02,	0x00,				// ReadƷк
	0xC5,	0x03,	0x00,				// ReadƷͺ
	//========================================================
};
//========================================================
// Function		: 
// Function API	: 
//========================================================
void SmokeMode_Handler(void)
{
	//========================================================
	static	unsigned	char	index = 0;
	//========================================================
	switch( ucSmokeMode_Event )
	{
		//========================================================
		case SMOKE_MODE_EVENT_INIT:
			//========================================================
			// HTK5020_Duty[7:2]
			//	xxxx_Done:	= 0 ʾ¼δ,ҪʼӦ¼
			//				= 1	ʾ¼
			//========================================================
			HTK5020_Duty = 0xF0;
//			bReadStatusEvent_Done = 0;		// tset	
			//========================================================
			HTK5020_StatusEvent = 0;
			ucSmoke_Event = SMOKE_EVENT_RECEIVE;
			Device_Memset(ucSmoke_Buffer,0,SMOKE_UART_LEN);
			//========================================================
			ucSmokeMode_Event++;
			ucSmokeMode_ResendCount = 0;
			ucSmokeMode_Register_0 = INIT_REGISTER_0;
			ucSmokeMode_Register_1 = INIT_REGISTER_1;
			ucSmokeMode_TimeCount = SMODE_API_TimeBase_256ms;
			//========================================================
			break;
			//========================================================
		case SMOKE_MODE_EVENT_INIT+1:
			//========================================================
			if( (bSmoke_Commu_Idle)&&
				((unsigned char)(SMODE_API_TimeBase_256ms-ucSmokeMode_TimeCount)>=MAX_SMOKE_RESEND_TIMEOUT) )
			{
				//========================================================
				ucSmokeMode_TimeCount = SMODE_API_TimeBase_256ms;
				//========================================================
				if( bSmoke_Commu_Done )
				{
					//========================================================
					index += 3;
					if( index>=(sizeof(Smoke_Mode_Init)) )
					{
						//========================================================
						ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
						//========================================================
					}
					//========================================================
					bSmoke_Commu_Done = 0;
					ucSmokeMode_ResendCount = 0;
					//========================================================
				}
				else
				{
					//========================================================
					ucSmokeMode_ResendCount++;
					if( ucSmokeMode_ResendCount>MAX_SMOKE_RESEND )
					{	// ͨѶط10Ȼ쳣
						//========================================================
						// 쳣:
						//========================================================
						bSmoke_Commu_Done = 1;
						ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
						//========================================================
					}
					//========================================================
				}
				//========================================================
				ucSmoke_Buffer[FRAME_LENGTH] = 0x02;
				ucSmoke_Buffer[FRAME_TAG]	 = Smoke_Mode_Init[index];
				ucSmoke_Buffer[FRAME_MEMBER] = Smoke_Mode_Init[index+1];
				ucSmoke_Buffer[FRAME_VALUE]  = Smoke_Mode_Init[index+2];
				//========================================================
				Uart_TLVC_Send_Read_Ack();
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case SMOKE_MODE_EVENT_IDLE:
			//========================================================
//			if(	(bReadSmokeMessage_Done==0)||(SMODE_API_ReadMessage_Flag) )	// test
			if(	(bReadSmokeMessage_Done==0)||
				((SMODE_API_ReadMessage_Flag)&&((ucSmokeMode_Register_0 & 0x0E)==0)) )
			{
				//========================================================
				// test_Register_0ϢԶϱǷʹ
				// test_ÿ12SȡHTK5020ģϢ
				// Register_0ϢԶϱֹ,ÿ12SȡHTK5020ģϢ
				// Register_0ϢԶϱʹ,ȴHTK5020ģԶϱ
				//========================================================
				SMODE_API_ReadMessage_ClrFlag;
				//========================================================
				bSmoke_Mode_Idle = 0;
				bSmoke_Commu_Done = 0;
				bReadSmokeMessage_Done = 0;
				ucSmokeMode_ResendCount = 0;
				ucSmokeMode_Event = SMOKE_MODE_EVENT_READ_MESSAGE;
				//========================================================
			}
//			else if( (bReadStatusEvent_Done==0)||(bPinWakeup_Done==0) )		// test
			else if( (bReadStatusEvent_Done==0)||
					 ((bPinWakeup_Done==0)&&((ucSmokeMode_Register_0 & 0x10)==0)) )
			{	// bPinWakeup_Done = 0;		Pin Wakeup
				//========================================================
				// test_Register_0ģ״̬ԶϱǷʹ
				// test_ֻҪHTK5020_Pin WakeupȡHTK5020ģ״̬
				// Register_0ģ״̬Զϱֹ,
				//		ֻҪHTK5020_Pin WakeupȡHTK5020ģ״̬
				// Register_0ģ״̬Զϱʹ,ȴHTK5020ģԶϱ
				//========================================================
				bPinWakeup_Done = 1;
				//========================================================
				bSmoke_Mode_Idle = 0;
				bSmoke_Commu_Done = 0;
				bReadStatusEvent_Done = 0;
				ucSmokeMode_ResendCount = 0;
				ucSmokeMode_Event = SMOKE_MODE_EVENT_READ_STATUS;
				//========================================================
			}
			else if( bWriteStatusEvent_Done==0 )
			{
				//========================================================
				bSmoke_Mode_Idle = 0;
				bSmoke_Commu_Done = 0;
				ucSmokeMode_ResendCount = 0;
				ucSmokeMode_Event = SMOKE_MODE_EVENT_WRITE_STATUS;
				//========================================================
			}
			else if( bPinWakeup_Done==0 )
				bPinWakeup_Done = 1;
			else
				bSmoke_Mode_Idle = 1;
			//========================================================
			ucSmokeMode_TimeCount = SMODE_API_TimeBase_1ms;
			//========================================================
			break;
			//========================================================
		case SMOKE_MODE_EVENT_READ_STATUS:
			//========================================================
			if( (bSmoke_Commu_Idle)&&
				((unsigned char)(SMODE_API_TimeBase_1ms-ucSmokeMode_TimeCount)>=10) )
			{
				//========================================================
				if( bReadStatusEvent_Done )
				{
					//========================================================
					ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
					//========================================================
				}
				else
				{
					//========================================================
					ucSmokeMode_ResendCount++;
					if( ucSmokeMode_ResendCount>MAX_SMOKE_RESEND )
					{	// ͨѶط10Ȼ쳣
						//========================================================
						// 쳣:
						//========================================================
						bSmoke_Commu_Done = 1;
						bReadStatusEvent_Done = 1;
						ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
						//========================================================
					}
					//========================================================
				}
				//========================================================
				ucSmoke_Buffer[FRAME_TAG]	 = 0xC3;
				ucSmoke_Buffer[FRAME_LENGTH] = 0x01;
				ucSmoke_Buffer[FRAME_MEMBER] = 0x00;
				ucSmokeMode_TimeCount = SMODE_API_TimeBase_1ms;
				//========================================================
				Uart_TLVC_Send_Read_Ack();
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case SMOKE_MODE_EVENT_WRITE_STATUS:
			//========================================================
			if( (bSmoke_Commu_Idle)&&
				((unsigned char)(SMODE_API_TimeBase_1ms-ucSmokeMode_TimeCount)>=10) )
			{
				//========================================================
				if( bWriteStatusEvent_Done )
				{
					//========================================================
					ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
					//========================================================
				}
				else
				{
					//========================================================
					ucSmokeMode_ResendCount++;
					if( ucSmokeMode_ResendCount>MAX_SMOKE_RESEND )
					{	// ͨѶط10Ȼ쳣
						//========================================================
						// 쳣:
						//========================================================
						bSmoke_Commu_Done = 1;
						bWriteStatusEvent_Done = 1;
						ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
						//========================================================
					}
					//========================================================
				}
				//========================================================
				ucSmoke_Buffer[FRAME_TAG]	 = 0x83;
				ucSmoke_Buffer[FRAME_LENGTH] = 0x02;
				ucSmoke_Buffer[FRAME_MEMBER] = 0x00;
				ucSmoke_Buffer[FRAME_VALUE]	 = HTK5020_StatusEvent;
				ucSmokeMode_TimeCount = SMODE_API_TimeBase_1ms;
				//========================================================
				Uart_TLVC_Send_Read_Ack();
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case SMOKE_MODE_EVENT_READ_MESSAGE:
			//========================================================
			if( (bSmoke_Commu_Idle)&&
				((unsigned char)(SMODE_API_TimeBase_1ms-ucSmokeMode_TimeCount)>=10) )
			{
				//========================================================
				if( bReadSmokeMessage_Done )
				{
					//========================================================
					ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
					//========================================================
				}
				else
				{
					//========================================================
					ucSmokeMode_ResendCount++;
					if( ucSmokeMode_ResendCount>MAX_SMOKE_RESEND )
					{	// ͨѶط10Ȼ쳣
						//========================================================
						// 쳣:
						//========================================================
						bSmoke_Commu_Done = 1;
						bReadSmokeMessage_Done = 1;
						ucSmokeMode_Event = SMOKE_MODE_EVENT_IDLE;	break;
						//========================================================
					}
					//========================================================
				}
				//========================================================
				HTK5020_Message = INIT_REGISTER_1;
				ucSmoke_Buffer[FRAME_TAG]	 = 0xC2;
				ucSmoke_Buffer[FRAME_LENGTH] = 0x01;
				ucSmoke_Buffer[FRAME_MEMBER] = HTK5020_Message;
				ucSmokeMode_TimeCount = SMODE_API_TimeBase_1ms;
				//========================================================
				Uart_TLVC_Send_Read_Ack();
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		default:
			//========================================================
			ucSmokeMode_Event = SMOKE_MODE_EVENT_INIT;
			//========================================================
			break;
			//========================================================
		//========================================================
	}
	//========================================================
}
//========================================================
// Function		: 
// Function API	: 
//========================================================
void SmokeMode_Uart_Handler(void)
{
	//========================================================
	unsigned	char	i,temp;
	//========================================================
	switch( ucSmoke_Event )
	{
		//========================================================
		case SMOKE_EVENT_RECEIVE:
			//========================================================
			SMODE_API_Receive_Interrupt_Enable;		// жEnable	
			//========================================================
			ucSmoke_Event++;
			ucSmoke_Data_Length = 0;
			ucSmoke_TimeCount = SMODE_API_TimeBase_1ms;
			//========================================================
			break;
			//========================================================
		case SMOKE_EVENT_RECEIVE+1:
			//========================================================
			if( (unsigned char)(SMODE_API_TimeBase_1ms-ucSmoke_TimeCount)>=10 )
			{
				//========================================================
				bSmoke_Commu_Idle = 1;
				ucSmoke_Data_Length = 0;
				ucSmoke_TimeCount = SMODE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case SMOKE_EVENT_RECEIVE+2:
			//========================================================
			temp = ucSmoke_Buffer[ucSmoke_Data_Length-1];	// checksum
			for(i=0;i<=(ucSmoke_Data_Length-2);i++)
				temp ^= ucSmoke_Buffer[i];					// Value Length Tag
			//========================================================
			if( temp==0 )
				ucSmoke_Event++;
			else
				ucSmoke_Event = SMOKE_EVENT_RECEIVE;		// Checksum error
			//========================================================
			break;
			//========================================================
		case SMOKE_EVENT_RECEIVE+3:
			//========================================================
			// Bit[7]		Bit[6]					Bit[50]
			// 0 = ACK; 	000 = Write/Upload; 	Tag
			// 1 = Send;	001 = Read;
			//========================================================
			ucSmoke_Event = SMOKE_EVENT_RECEIVE;
			//========================================================
			switch( ucSmoke_Buffer[FRAME_TAG]&TAG_COMMAND_GROUP )
			{
				//========================================================
				case TAG_SMOKE_MESSAGE: 	// Bit[5:0] Smoke Message
					//========================================================
					if( (ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)&&
						((ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND)==0) )
					{	// Cmd_ACK_Read		Read_Ϣ
						//========================================================
						bSmoke_Commu_Done = 1;
						bReadSmokeMessage_Done = 1;
						//========================================================
						Read_HTK5020_Message(FRAME_VALUE,ucSmoke_Buffer[FRAME_MEMBER]);
						//========================================================
					}
					else if(	((ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)==0)&&
								(ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND) )
					{	// Cmd_Send_Upload	ϱϢ_/豸Ӧ
						//========================================================
						Read_HTK5020_Message(FRAME_VALUE,ucSmoke_Buffer[FRAME_MEMBER]);
						//========================================================
						ucSmoke_Buffer[FRAME_TAG] &= TAG_ACK;
						ucSmoke_Buffer[FRAME_LENGTH] = 0x01;
						//========================================================
						Uart_TLVC_Send_Read_Ack();
						//========================================================
					}
					//========================================================
					break;
					//========================================================
				//========================================================
				case TAG_STATUS_EVENT:		// Bit[5:0] Status_Event
					//========================================================
					if( ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_STATUS_EVENT )
					{
						//========================================================
						if( (ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)&&
							((ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND)==0) )
						{	// Cmd_ACK_Read	Read_HTK5020ģе״̬/¼
							//========================================================
							bSmoke_Commu_Done = 1;
							bReadStatusEvent_Done = 1;
							HTK5020_StatusEvent = ucSmoke_Buffer[FRAME_VALUE];
							//========================================================
						}
						else if(	((ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)==0)&&
									((ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND)==0) )
						{	// Cmd_ACK_Write	Write_HTK5020ģе״̬/¼
							//========================================================
							bSmoke_Commu_Done = 1;
							bWriteStatusEvent_Done = 1;
							//========================================================
						}
						else if(	((ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)==0)&&
									(ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND) )
						{	// Cmd_Send_Upload	Upload_HTK5020ģе״̬/¼_/豸Ӧ
							//========================================================
							HTK5020_StatusEvent = ucSmoke_Buffer[FRAME_VALUE];
							ucSmoke_Buffer[FRAME_TAG] &= TAG_ACK;
							ucSmoke_Buffer[FRAME_LENGTH] = 0x02;
							//========================================================
							Uart_TLVC_Send_Read_Ack();
							//========================================================
						}
						//========================================================
					}
					//========================================================
					break;
					//========================================================
				//========================================================
				case TAG_REGISTER:			// Bit[5:0] Register
					//========================================================
					if( (ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)&&
						((ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND)==0) )
					{	// Cmd_ACK_Read
						//========================================================
						if( ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_REGISTER_0 )
						{	// ƼĴ0_Read
							//========================================================
							bSmoke_Commu_Done = 1;
							ucSmokeMode_Register_0 = ucSmoke_Buffer[FRAME_VALUE];
							//========================================================
						}
						else if( ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_REGISTER_1 )
						{	// ƼĴ1_Read
							//========================================================
							bSmoke_Commu_Done = 1;
							ucSmokeMode_Register_1 = ucSmoke_Buffer[FRAME_VALUE];
							//========================================================
						}
						//========================================================
					}
					else if(	((ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)==0)&&
								((ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND)==0) )
					{	// Cmd_ACK_Write
						//========================================================
						if(	(ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_REGISTER_0)||
							(ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_REGISTER_1)||
							(ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_REGISTER_RESET) )
						{	// Write	ƼĴ0_ƼĴ1_ƼĴRESET
							//========================================================
							bSmoke_Commu_Done = 1;
							//========================================================
						}
						//========================================================
					}
					//========================================================
					break;
					//========================================================
				//========================================================
				case TAG_MESSAGE:			// Bit[5:0] Message
					//========================================================
					if( (ucSmoke_Buffer[FRAME_TAG]&TAG_CMD)&&
						((ucSmoke_Buffer[FRAME_TAG]&TAG_ACK_SEND)==0) )
					{	// Cmd_ACK_Read
						//========================================================
						if( ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_SOFTWARE_VERSION )
						{	// ȡ
							//========================================================
							bSmoke_Commu_Done = 1;
							SoftwareVersion[0] = ucSmoke_Buffer[FRAME_VALUE];
							SoftwareVersion[1] = ucSmoke_Buffer[FRAME_VALUE+1];
							SoftwareVersion[2] = ucSmoke_Buffer[FRAME_VALUE+2];
							SoftwareVersion[3] = ucSmoke_Buffer[FRAME_VALUE+3];
							//========================================================
						}
						else if( ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_HARDWARE_VERSION )
						{	// ȡӲ
							//========================================================
							bSmoke_Commu_Done = 1;
							HardwareVersion[0] = ucSmoke_Buffer[FRAME_VALUE];
							HardwareVersion[1] = ucSmoke_Buffer[FRAME_VALUE+1];
							HardwareVersion[2] = ucSmoke_Buffer[FRAME_VALUE+2];
							HardwareVersion[3] = ucSmoke_Buffer[FRAME_VALUE+3];
							//========================================================
						}
						else if( ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_SERIAL_NUMBER )
						{	// Ʒк
							//========================================================
							bSmoke_Commu_Done = 1;
							for(i=0;i<(ucSmoke_Buffer[FRAME_LENGTH]-1);i++)
								Serial_Number[i] = ucSmoke_Buffer[FRAME_VALUE+i];
							//========================================================
						}
						else if( ucSmoke_Buffer[FRAME_MEMBER]==MEMBER_PART_NUMBER )
						{	// Ʒͺ
							//========================================================
							bSmoke_Commu_Done = 1;
							for(i=0;i<(ucSmoke_Buffer[FRAME_LENGTH]-1);i++)
								Part_Number[i] = ucSmoke_Buffer[FRAME_VALUE+i];
							//========================================================
						}
						//========================================================
					}
					//========================================================
					break;
					//========================================================
				default:
					//========================================================
					ucSmoke_Event = SMOKE_EVENT_RECEIVE;
					//========================================================
					break;
					//========================================================
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		//========================================================
		//==EVBʹSCĴ==SCĴ Send================
		//========================================================
		case SMOKE_EVENT_SEND_LOAD:
			//========================================================
			ucSmoke_Event++;
			//========================================================
			SMODE_API_Data_Buffer = 0xFF;					// ݻ
			SMODE_API_Send_Interrupt_ClrFlag;				// ʹܴλ
			//========================================================
			break;
			//========================================================
		case SMOKE_EVENT_SEND_LOAD+1:
			//========================================================
			if( SMODE_API_Send_Interrupt_Flag ) 			// ͻ״̬־λ(ֻ)
			{
				//========================================================
				if( ucSmoke_Data_Length )
				{
					//========================================================
					SMODE_API_Data_Buffer = ucSmoke_Buffer[ucSmoke_Length_Count++]; 	// ݻ
					SMODE_API_Send_Interrupt_ClrFlag;		// ʹܴλ
					//========================================================
					ucSmoke_Data_Length--;
					//========================================================
				}
				else
					ucSmoke_Event = SMOKE_EVENT_RECEIVE;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		//========================================================
		//==Uart Send=============================================
		//========================================================
/*		case SMOKE_EVENT_SEND_LOAD:
			//========================================================
			SMODE_API_Send_Interrupt_ClrFlag;		// ж״̬־λClr
			SMODE_API_Data_Buffer = 0xFF;			// ݻ
			ucSmoke_Event++;
			//========================================================
			break;
			//========================================================
		case SMOKE_EVENT_SEND_LOAD+1:
			//========================================================
			if( SMODE_API_Send_Interrupt_Flag ) 	// ж״̬־λ	
			{
				//========================================================
				SMODE_API_Send_Interrupt_ClrFlag;	// ж״̬־λClr
				//========================================================
				if( ucSmoke_Data_Length )
				{
					//========================================================
					SMODE_API_Data_Buffer = ucSmoke_Buffer[ucSmoke_Length_Count++]; 	// ݻ
					ucSmoke_Data_Length--;
					//========================================================
				}
				else
					ucSmoke_Event = SMOKE_EVENT_RECEIVE;
				//========================================================
			}
			//========================================================
			break;
*/			//========================================================
		default:
			//========================================================
			ucSmoke_Event = SMOKE_EVENT_RECEIVE;
			//========================================================
			break;
			//========================================================
		//========================================================
	}
}
//========================================================
// Function		: UART2 interrupt subroutine.
// Function API	: 
//========================================================
void SMC0_ISR (void) interrupt 19		// UART2 interrupt	009BH	19
{
	//========================================================
	if( SMODE_API_Receive_Interrupt_Flag )				// ж״̬־λ(ֻ)
	{
		//========================================================
		SMODE_API_Receive_Interrupt_ClrFlag;			// ж״̬־λClr	
		ucSmoke_Buffer[ucSmoke_Data_Length++] = SMODE_API_Data_Buffer;	// ݻ
		//========================================================
		bSmoke_Commu_Idle = 0;
		ucSmoke_TimeCount = SMODE_API_TimeBase_1ms;
		//========================================================
		if( ucSmoke_Buffer[FRAME_TAG]==FRAME_HEADER_FF )
		{
			//========================================================
			ucSmoke_Data_Length = 0;
			//========================================================
		}
		else
		{
			//========================================================
			if( ucSmoke_Data_Length==(ucSmoke_Buffer[FRAME_LENGTH]+FRAME_VALUE) )
			{
				//========================================================
				ucSmoke_Event++;
				//========================================================
				SMODE_API_Receive_Interrupt_Disabled;	// жDisabled
				//========================================================
			}
			//========================================================
		}
		//========================================================
	}
	//========================================================
}
//========================================================
#endif
//========================================================
// Function		: 
// Function API	: 
//========================================================
