//==============================================================
// File		: SmokeMode.h
// Author	: wzh
// Version	: V1.0
// Date		: 21.11.01
//==============================================================

//Define to prevent recursive inclusion=========================
#ifndef SmokeMode_H
#define	SmokeMode_H

//==============================================================
// Section: Included Files
//==============================================================

//==============================================================
#ifdef GLOBAL_SmokeMode
    #define EXT_SmokeMode
#else
    #define EXT_SmokeMode extern
#endif
//==============================================================
// Section: Exported Constants
//==============================================================
#define	FRAME_HEADER_FF					0xFF	// 0xFF
#define	FRAME_TAG						0		// Tag		Command Group
#define	FRAME_LENGTH					1		// Length
#define	FRAME_MEMBER					2		// Value_1	Command Group Member
#define	FRAME_VALUE						3		// Value_2
#define	FRAME_CHECKSUM					(ucSmoke_Buffer[FRAME_LENGTH]+2)
//==Tag=========================================================
#define	TAG_ACK_SEND					0x80	// Bit[7]	1 = Send;	0 = ACK;
#define	TAG_ACK							0x7F	// Bit[7]	ACK
#define	TAG_CMD							0x40	// Bit[6]	1 = Read;	0 = Write/Upload;
#define	TAG_COMMAND_GROUP				0x3F	// Bit[5:0]	Command Group

#define	TAG_SMOKE_MESSAGE				0x02	// Bit[5:0]	Smoke Message
#define	TAG_STATUS_EVENT				0x03	// Bit[5:0]	Status_Event
#define	TAG_REGISTER					0x04	// Bit[5:0]	Register
#define	TAG_MESSAGE						0x05	// Bit[5:0]	Message
//==Member_SMOKE_MESSAGE========================================
#define	MEMBER_DATA_SWITCH				0x01	// 
//==Member_STATUS===============================================
#define	MEMBER_STATUS_EVENT				0x00	// HTK5020ģе״̬/¼ReadWrite
//==Member_REGISTER=============================================
#define	MEMBER_REGISTER_0				0x00	// Register_0
#define	MEMBER_REGISTER_1				0x01	// Register_1
#define	MEMBER_REGISTER_RESET			0xFF	// Register_reset
//==Member_MESSAGE==============================================
#define	MEMBER_SOFTWARE_VERSION			0x00	// Software Version	汾
#define	MEMBER_HARDWARE_VERSION			0x01	// Hardware Version	Ӳ汾
#define	MEMBER_SERIAL_NUMBER			0x02	// Serial Number	Ʒк
#define	MEMBER_PART_NUMBER				0x03	// Part Number		Ʒͺ
//==Register====================================================
#define	INIT_REGISTER_0					0x55	// Register_0	55	50
#define	INIT_REGISTER_1					0x0F	// Register_1	0F
//==SMOKE_EVENT=================================================
#define	SMOKE_EVENT_RECEIVE				0		// Receive	Rx
#define	SMOKE_EVENT_SEND_LOAD			10		// Tx
//==SMOKE_MODE_EVENT============================================
#define	SMOKE_MODE_EVENT_INIT			0
#define	SMOKE_MODE_EVENT_IDLE			10
#define	SMOKE_MODE_EVENT_READ_STATUS	15
#define	SMOKE_MODE_EVENT_WRITE_STATUS	20
#define	SMOKE_MODE_EVENT_READ_MESSAGE	25
//==============================================================
#define	MAX_SMOKE_RESEND				10		// 10
#define	MAX_SMOKE_RESEND_TIMEOUT		2		// 2*256ms = 512ms
//==============================================================
// Section: Exported Variables
//==============================================================
#define SMOKE_UART_LEN		50
EXT_SmokeMode unsigned char			ucSmoke_Data_Length;
EXT_SmokeMode unsigned char			ucSmoke_Length_Count;
EXT_SmokeMode unsigned char			ucSmoke_Buffer[SMOKE_UART_LEN];
//==============================================================
EXT_SmokeMode unsigned char			SoftwareVersion[4];
EXT_SmokeMode unsigned char			HardwareVersion[4];
EXT_SmokeMode unsigned char			Serial_Number[10];
EXT_SmokeMode unsigned char			Part_Number[10];
EXT_SmokeMode unsigned char			Type_Value,Shade_Value;
EXT_SmokeMode unsigned short		Ir_Value,Blue_Value,Red_Value,Temp_Value;
//==============================================================
EXT_SmokeMode unsigned		char	bdata	HTK5020_Duty;
EXT_SmokeMode unsigned		char	bdata	HTK5020_StatusEvent;
EXT_SmokeMode unsigned		char	bdata	HTK5020_Message;
//==============================================================
EXT_SmokeMode unsigned		char	data	ucSmoke_Event;					// Event
EXT_SmokeMode unsigned		char	data	ucSmokeMode_Event;				// Event
EXT_SmokeMode unsigned		char	data	ucSmokeMode_Register_0;			// Register_0
EXT_SmokeMode unsigned		char	data	ucSmokeMode_Register_1;			// Register_1
EXT_SmokeMode unsigned		char	data	ucSmokeMode_ResendCount;		// Resend Count
EXT_SmokeMode volatile	unsigned	char	data	ucSmoke_TimeCount;		// TimeCount
EXT_SmokeMode volatile	unsigned	char	data	ucSmokeMode_TimeCount;	// TimeCount
//==============================================================
#ifdef	GLOBAL_SmokeMode
	//==HTK5020_Duty================================================
	sbit bSmoke_Commu_Idle		= HTK5020_Duty^0;
	sbit bSmoke_Mode_Idle		= HTK5020_Duty^1;
	sbit bSmoke_Commu_Done 		= HTK5020_Duty^2;
	sbit bSmoke_ModeInit_Done	= HTK5020_Duty^3;
	sbit bPinWakeup_Done		= HTK5020_Duty^4;
	sbit bReadSmokeMessage_Done = HTK5020_Duty^5;
	sbit bReadStatusEvent_Done	= HTK5020_Duty^6;
	sbit bWriteStatusEvent_Done	= HTK5020_Duty^7;
	//==HTK5020_StatusEvent=========================================
	sbit bInit_Exception		= HTK5020_StatusEvent^0;
	sbit bAdpd_Commu_Exception	= HTK5020_StatusEvent^2;
	sbit bMode_Fault			= HTK5020_StatusEvent^3;
	sbit bInit_Complete 		= HTK5020_StatusEvent^4;
	sbit bCharmber_Dirty		= HTK5020_StatusEvent^6;
	sbit bSmoke_Alarm			= HTK5020_StatusEvent^7;
	//==HTK5020_Message=============================================
	sbit bType_Switch			= HTK5020_Message^0;
	sbit bShade_Switch			= HTK5020_Message^1;
	sbit bIr_Switch 			= HTK5020_Message^2;
	sbit bBlue_Switch			= HTK5020_Message^3;
	sbit bRed_Switch			= HTK5020_Message^4;
	sbit bTemp_Switch			= HTK5020_Message^5;
	//==============================================================
#else
	//==HTK5020_Duty================================================
	extern	bit	bSmoke_Commu_Idle,bSmoke_Mode_Idle;
	extern	bit	bSmoke_Commu_Done,bSmoke_ModeInit_Done;
	extern	bit	bPinWakeup_Done,bReadSmokeMessage_Done;
	extern	bit	bReadStatusEvent_Done,bWriteStatusEvent_Done;
	//==HTK5020_StatusEvent=========================================
	extern	bit bInit_Exception,bAdpd_Commu_Exception,bMode_Fault;
	extern	bit bInit_Complete,bSmoke_Alarm,bCharmber_Dirty;
	//==HTK5020_Message=============================================
	extern	bit bType_Switch,bShade_Switch,bTemp_Switch;
	extern	bit bIr_Switch,bBlue_Switch,bRed_Switch;
	//==============================================================
#endif	//#ifdef GLOBAL_SmokeMode
//==============================================================
// Section: Exported Interface
//==============================================================
	//==============================================================
	// SMODE = Smoke Mode
	// API = Interface
	// SMODE_API = Smoke Mode Interface
	//==============================================================
	//==Smoke Mode Interface Output=============================
	//==============================================================
	#define	SMODE_API_Init							(ucSmokeMode_Event = SMOKE_MODE_EVENT_INIT)
	//==============================================================
	#define	SMODE_API_HTK5020_Duty					(HTK5020_Duty)
	#define	SMODE_API_Commu_Idle					(bSmoke_Commu_Idle)
	#define	SMODE_API_ModeInit_Done					(bSmoke_ModeInit_Done)
	#define	SMODE_API_PinWakeup_Done				(bPinWakeup_Done)
	#define SMODE_API_ReadSmokeMessage_Done 		(bReadSmokeMessage_Done)
	#define SMODE_API_ReadStatusEvent_Done 			(bReadStatusEvent_Done)
	#define SMODE_API_WriteStatusEvent_Done			(bWriteStatusEvent_Done)
	//==============================================================
	#define	SMODE_API_HTK5020_StatusEvent			(HTK5020_StatusEvent)
	#define	SMODE_API_Init_Exception				(bInit_Exception)
	#define SMODE_API_Adpd_Commu_Exception			(bAdpd_Commu_Exception)
	#define SMODE_API_Fault							(bMode_Fault)
	#define	SMODE_API_Init_Complete					(bInit_Complete)
	#define SMODE_API_Charmber_Dirty 				(bCharmber_Dirty)
	#define	SMODE_API_Alarm							(bSmoke_Alarm)
	//==============================================================
	//==Smoke Mode Interface Input==================================
	//==============================================================				// EVBʹSCĴ			UART
	#define SMODE_API_TimeBase_1ms					(ucTimeCount_Base)
	#define SMODE_API_TimeBase_256ms				(ucTimeBase_256ms)
	//==============================================================
	#define SMODE_API_ReadMessage_Flag 				(ReadSmokeMessage_12s==0)
	#define SMODE_API_ReadMessage_ClrFlag			(ReadSmokeMessage_12s=2)
	//==============================================================				// EVBʹSCĴ			UART
	#define SMODE_API_Data_Buffer 					(SC0DR) 						// ݻ					ݻ
	#define SMODE_API_Receive_Interrupt_Enable		(SC0IE |= SET_BIT0)				// жEnable				UARTжEnable
	#define SMODE_API_Receive_Interrupt_Disabled 	(SC0IE &= CLR_BIT0) 			// жDisabled				UARTжDisabled	
	#define SMODE_API_Receive_Interrupt_Flag		((SC0IS&SET_BIT0)==SET_BIT0)	// ж״̬־λ				ж״̬־λ
	#define SMODE_API_Receive_Interrupt_ClrFlag 	(SC0IS &= CLR_BIT0)				// ж״̬־λClr				ж״̬־λClr
	#define SMODE_API_Send_Interrupt_Flag			((SC0TSR|CLR_BIT3)!=CLR_BIT3)	// ͻ״̬־λ				ж״̬־λ
	#define SMODE_API_Send_Interrupt_ClrFlag		(SC0CR0 &= CLR_BIT2)			// ʹܴλ					ж״̬־λClr
//==============================================================
// Section: Exported Functions
//==============================================================
void SmokeMode_Handler(void);
void SmokeMode_Uart_Handler(void);
//==============================================================
// Section: End Of file
//==============================================================
#endif
