//========================================================
// File			: Voice.c
// Author		: wzh
// Version		: V1.0
// Date			: 21.04.21
//========================================================
#define GLOBAL_Voice			//GLOBALS, ʾеȫֱڱļж
//========================================================
// Section: Included Files
//========================================================
#include "../main.h"
#include "../Library/Device/Include/ML51.h"
//========================================================
// Section: Macro Declarations
//========================================================

//========================================================
#if		1
//========================================================
// Function		: 
// Function API	: 
//========================================================
_stVoice_Device *Voice_Get_Event(_stVoice_Queue *FrameList)
{
	//========================================================
	unsigned char	idx;
	//========================================================
	if( FrameList->Queue_cnt==0 )
		return	0;
	idx = FrameList->Queue_idx;
	FrameList->Queue_idx = (FrameList->Queue_idx + 1) % Voice_Queue_Size;
	FrameList->Queue_cnt--;
	//========================================================
	return	&FrameList->Queue_Data[idx];
	//========================================================
}
//========================================================
// Function		: 
// Function API	: 
//========================================================
unsigned char Voice_Put_Event(_stVoice_Device *event,_stVoice_Queue *FrameList)
{
	//========================================================
	unsigned char idx;
	//========================================================
	if( FrameList->Queue_cnt>=Voice_Queue_Size )
		return	0;
	idx = (FrameList->Queue_idx + FrameList->Queue_cnt) % Voice_Queue_Size;
	FrameList->Queue_Data[idx] = *event;
	FrameList->Queue_cnt++;
	return	1;
	//========================================================
}
//========================================================
// Function		: 
// Function API	: 
//========================================================
void Voice_Clear_Event(_stVoice_Queue *FrameList)
{
	//========================================================
	FrameList->Queue_idx = 0;
	FrameList->Queue_cnt = 0;
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
// Function		: 
// Function API	: 
//========================================================
void Tone_Stop(void)
{
	//========================================================
	ucVoice_Init = 1;
	ucVoice_Play_Tone_Index = 0;					// index of first tone is 1; 0 means play nothing
	ucVoice_Event = VOICE_EVENT_PLAY;
	//========================================================
}
//========================================================
// Function		: 
// Function API	: 
//========================================================
void Play_The_Voice(unsigned char tone_index)
{
	//========================================================
	VOICE_API_Idle = 0;
	stVoice_Device.Play_Tone_Index = tone_index;	// index of first tone is 1; 0 means play nothing
	Voice_Put_Event(&stVoice_Device,&stVoice_Queue);
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
// Function 	: 
// Function API : 
//	1) clock puls=100uS
//	2) nPlus and nPlus_Reset are Open-Drain, should be output 1 while idle, for less current.
//	3) nPlus and nPlus_Reset affect at rising-edge.
//========================================================
void Voice_Handler(void)
{
	//========================================================
	_stVoice_Device *stVoice_Device_Play;
	//========================================================
	switch(ucVoice_Event)
	{
		//========================================================
		case VOICE_EVENT_INIT:
			//========================================================
			PIN_NSP_VBAT_CONTROL = 0;
			//========================================================
			ucVoice_Event++;
			ucVoice_Init = 1;
			ucVoice_Play_Tone_Index = 0;
			ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_INIT+1:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=100 )
			{
				//========================================================
				Voice_Ic_Clock = 0;
				Voice_Ic_Reset = 0;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_INIT+2:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
			{
				//========================================================
				Voice_Ic_Clock = 0;
				Voice_Ic_Reset = 1;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_INIT+3:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
			{
				//========================================================
				Voice_Ic_Clock = 0;
				Voice_Ic_Reset = 0;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_INIT+4:	// wait timeout to enter idle
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=100 )
			{
				//========================================================
				ucVoice_Init = 0;
				ucVoice_Event = VOICE_EVENT_IDLE;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY:
			//========================================================
			if( ucVoice_Play_Tone_Index )
			{
				//========================================================
				Voice_Ic_Clock = 0;
				Voice_Ic_Reset = 0;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			else if( ucVoice_Init )
				ucVoice_Event = VOICE_EVENT_INIT;
			else
				ucVoice_Event = VOICE_EVENT_IDLE;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+1:	// delay for wakeup to work..... 
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=50 )
			{
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+2:
			//========================================================
			Voice_Ic_Clock = 0;
			Voice_Ic_Reset = 0;
			//========================================================
			ucVoice_Event++;
			ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+3:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
			{
				//========================================================
				Voice_Ic_Reset = 1;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+4:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
			{
				//========================================================
				Voice_Ic_Reset = 0;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+5:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
			{
				//========================================================
				Voice_Ic_Clock = 1;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+6:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
			{
				//========================================================
				Voice_Ic_Clock = 0;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+7:
			//========================================================
			if( --ucVoice_Play_Tone_Index )
				ucVoice_Event = VOICE_EVENT_PLAY+5;
			else
				ucVoice_Event++;
			//========================================================
			ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+8:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
				ucVoice_Event++;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+9:
			//========================================================
			if( nVoice_Ic_Busy )
				ucVoice_Event++;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+10:  
			//========================================================
			Voice_Ic_Clock = 0;
			Voice_Ic_Reset = 1;  
			//========================================================
			ucVoice_Event++;
			ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_PLAY+11:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=1 )
			{
				//========================================================
				Voice_Ic_Clock = 0;
				Voice_Ic_Reset = 0;
				//========================================================
				ucVoice_Event = VOICE_EVENT_IDLE;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_IDLE:
			//========================================================
			stVoice_Device_Play = Voice_Get_Event(&stVoice_Queue);
			if( stVoice_Device_Play )
			{
				//========================================================
				VOICE_API_Idle = 0;
				//========================================================
				ucVoice_Event++;
				ucVoice_TimeCount = VOICE_API_TimeBase_1ms;
				ucVoice_Play_Tone_Index = stVoice_Device_Play->Play_Tone_Index;
				//========================================================
			}
			else
				VOICE_API_Idle = 1;
			//========================================================
			break;
			//========================================================
		case VOICE_EVENT_IDLE+1:
			//========================================================
			if( (unsigned char)(VOICE_API_TimeBase_1ms - ucVoice_TimeCount)>=100 )
			{
				//========================================================
				ucVoice_Event = VOICE_EVENT_PLAY;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		default:
			//========================================================
			ucVoice_Event = VOICE_EVENT_INIT;
			//========================================================
			break;
			//========================================================
		//========================================================
	}
	//========================================================
}
//========================================================
#endif
//========================================================
