//==============================================================
// File			: Voice.h
// Author		: wzh
// Version		: V1.0
// Date			: 21.04.21
//==============================================================

//Define to prevent recursive inclusion=========================
#ifndef Voice_H
#define	Voice_H

//==============================================================
// Section: Included Files
//==============================================================

//==============================================================
#ifdef GLOBAL_Voice
    #define EXT_Voice
#else
    #define EXT_Voice extern
#endif
//==============================================================
// Section: Exported Constants
//==============================================================
#define	Voice_Queue_Size		10
//==VOICE_EVENT=================================================
#define	VOICE_EVENT_INIT		0		// Init
#define	VOICE_EVENT_PLAY 		10		// Play the voice
#define	VOICE_EVENT_IDLE		40
//==============================================================
// Section: Exported Variables
//==============================================================
typedef struct 
{
	//==============================================================
	unsigned	char	Play_Tone_Index;
	//==============================================================
}_stVoice_Device;

EXT_Voice _stVoice_Device	data	stVoice_Device;
//==============================================================
typedef struct
{
	//==============================================================
	unsigned	char	Queue_idx;
	unsigned	char	Queue_cnt;
	_stVoice_Device		Queue_Data[Voice_Queue_Size];
	//==============================================================
}_stVoice_Queue;

EXT_Voice _stVoice_Queue	data	stVoice_Queue;
//==============================================================
EXT_Voice unsigned		char	data	ucVoice_Init;				// Init
EXT_Voice unsigned		char	data	ucVoice_Play_Tone_Index;	// Play Tone Index
EXT_Voice unsigned		char	data	ucVoice_Event;				// Event
EXT_Voice volatile	unsigned	char	data	ucVoice_TimeCount;	// Time Count
//==============================================================
// Section: Exported Interface
//==============================================================
#define Voice_Ic_Clock				P21
#define Voice_Ic_Reset				P22
#define nVoice_Ic_Busy				P23
#define PIN_NSP_VBAT_CONTROL		P03
//==============================================================
	//==============================================================
	// VOICE_API = Voice Interface
	//==============================================================
	//==Device Communication Interface Output=======================
	//==============================================================
	#define VOICE_API_Init 				(ucVoice_Event = VOICE_EVENT_INIT)
	//==============================================================
	//==Device Communication Interface Input========================
	//==============================================================
	#define VOICE_API_Idle				(bDevice_Voice_Idle)
	#define VOICE_API_TimeBase_1ms 		(ucTimeCount_Base)
//==============================================================
// Section: Exported Functions
//==============================================================
void Voice_Handler(void);
//==============================================================
void Tone_Stop(void);
void Play_The_Voice(unsigned char tone_index);
void Voice_Clear_Event(_stVoice_Queue *FrameList);
//==============================================================
// Section: End Of file
//==============================================================
#endif
