//==============================================================
// File		: Hardware.h
// Author	: wzh
// Version	: V1.0
// Date		: 20.09.29
//==============================================================

//Define to prevent recursive inclusion=========================
#ifndef Hardware_H
#define	Hardware_H
//==============================================================
// Section: Included Files
//==============================================================

//==============================================================
// Section: Exported Constants
//==============================================================
// TIMER1_FSYS;			1/1
// TIMER1_FSYS_DIV12;	1/12
#define	TH0_INIT		((unsigned char)((65536-(1000/12*(24000000/1000000)))>>8))
#define	TL0_INIT		((unsigned char)((65536-(1000/12*(24000000/1000000)))&0xFF))
//==============================================================
#define SET_BIT0		0x01
#define SET_BIT1		0x02
#define SET_BIT2		0x04
#define SET_BIT3		0x08
#define SET_BIT4		0x10
#define SET_BIT5		0x20
#define SET_BIT6		0x40
#define SET_BIT7		0x80

#define CLR_BIT0		0xFE
#define CLR_BIT1		0xFD
#define CLR_BIT2		0xFB
#define CLR_BIT3		0xF7
#define CLR_BIT4		0xEF
#define CLR_BIT5		0xDF
#define CLR_BIT6		0xBF
#define CLR_BIT7		0x7F
//==============================================================
#define LED_PIN_RED					P24
#define LED_PIN_GREEN				P25
//==============================================================
#define KEY_PIN_SW1					P46
//==============================================================
// SMODE = Smoke Mode
//==============================================================
#define SMODE_PIN_INIT				P00		// In-Put Mode
#define SMODE_PIN_WAKEUP			P01		// In-Put Mode
#define SMODE_PIN_ALARM				P02		// In-Put Mode
#define SMODE_PIN_IO4				P20
//==============================================================
// Section: Exported Variables
//==============================================================

//==============================================================
// Section: Exported Functions
//==============================================================
void Hardware_Init(void);
void Clear_WDT_Timer(void);
void Enter_Deep_Sleep(void);
//==============================================================
// Section: End Of file
//==============================================================
#endif
