//Define to prevent recursive inclusion=========================
#ifndef Ht1621_H
#define Ht1621_H
//==============================================================
// Section: Included Files
//==============================================================

//==============================================================
// Section: Exported Constants
//==============================================================
#define NUL					0x00
#define	ON					0x01
#define	OFF					0x00
//==COM=========================================================
#define	BAT_SEG_ADDR		31
#define	DIGIST1H_SEG_ADDR	30
#define	DIGIST1L_SEG_ADDR	29
#define	DIGIST2H_SEG_ADDR	28
#define	DIGIST2L_SEG_ADDR	27
#define	DIGIST3H_SEG_ADDR	26
#define	DIGIST3L_SEG_ADDR	25
#define	DIGIST4H_SEG_ADDR	24
#define	DIGIST4L_SEG_ADDR	23
#define	DIGIST5H_SEG_ADDR	22
#define	DIGIST5L_SEG_ADDR	21
#define	DIGIST6H_SEG_ADDR	20
#define	DIGIST6L_SEG_ADDR	19
#define	DEGREE_SEG_ADDR		18
//==SEG=========================================================
#define SYM_Celsius			0x08	//				϶			DEGREE_SEG_ADDR
#define SYM_Fahrenheit		0x04	//H				϶			DEGREE_SEG_ADDR
#define	SYM_Buzzer			0x02	//Buzzer					DEGREE_SEG_ADDR
#define	SYM_TEMP			0x02	//TEMP						BAT_SEG_ADDR

#define SYM_TEMP_Normal		0x10	//TEMP_Normal	Ц			DIGIST1H_SEG_ADDR
#define SYM_TEMP_Fever		0x10	//TEMP_Fever				DIGIST2H_SEG_ADDR
#define	SYM_OBJ				0x10	//OBJ			¶		DIGIST3H_SEG_ADDR
#define SYM_Memory			0x10	//Memory					DIGIST4H_SEG_ADDR
#define SYM_Point			0x10	//Point			.			DIGIST6H_SEG_ADDR
//==SEG=========================================================
#define SYM_Vbat			0x01	//Vbat			   		DEGREE_SEG_ADDR
#define SYM_Vbat1			0x10	//Vbat1			   1	DIGIST5H_SEG_ADDR
#define SYM_Vbat2			0x04	//Vbat2			   2	BAT_SEG_ADDR
#define SYM_Vbat3			0x08	//Vbat3			   3	BAT_SEG_ADDR
//==SEG=========================================================
#define A				0x08
#define B				0x04
#define C				0x02
#define D				0x01
#define E				0x20
#define F				0x80
#define G				0x40
#define DP				0x10		//SYM_Point
#define CHBLANK			0x00
//==SEG=========================================================
#define CHASK			A|B|E|G			// ?
#define CHPLUS			G
#define CHnum			A|B|G|E|D|DP
//=='0'-'9'=====================================================
#define CH00			A|B|C|D|E|F
#define CH01			B|C
#define CH02			A|B|G|E|D
#define CH03			A|B|C|D|G
#define CH04			B|C|F|G
#define CH05			A|C|D|F|G
#define CH06			A|C|D|E|F|G
#define CH07			A|B|C
#define CH08			A|B|C|D|E|F|G
#define CH09			A|B|C|D|F|G
//=='A'-'Z'=====================================================
#define CHA				A|B|C|E|F|G
#define CHB				C|D|E|F|G
#define CHC				A|D|E|F
#define CHD				B|C|D|E|G
#define CHE				A|D|E|F|G
#define CHF				A|E|F|G
#define CHG				A|C|D|E|F
#define CHH				B|C|E|F|G
#define CHI				B|C
#define CHJ				B|C|D
#define CHK				E|F|G
#define CHL				D|E|F
#define CHM				CHBLANK
#define CHN				A|B|C|E|F
#define CHO				A|B|C|D|E|F
#define CHP				A|B|E|F|G
#define CHQ				CHBLANK
#define CHR				E|G
#define CHS				A|C|D|F|G
#define CHT				D|E|F|G
#define CHU				B|C|D|E|F
#define CHV				B|C|D|E|F
#define CHW				CHBLANK
#define CHX				CHBLANK
#define CHY				B|C|D|F|G
#define CHZ				A|B|E|D
//=='a'-'z'=====================================================
#define CHa				CHBLANK
#define CHb				C|D|E|F|G
#define CHc				D|E|G
#define CHd				B|C|D|E|G
#define CHe				A|B|D|E|F|G
#define CHf				A|E|F|G
#define CHg				A|B|C|D|F|G
#define CHh				C|E|F|G
#define CHi				C
#define CHj				C|D
#define CHk				E|F|G
#define CHl				D|E
#define CHm				CHBLANK
#define CHn				C|E|G
#define CHo				C|D|E|G
#define CHp				A|D|E|F|G
#define CHq				A|B|C|F|G
#define CHr				E|G
#define CHs				CHBLANK
#define CHt				D|E|F|G
#define CHu				C|D|E
#define CHv				C|D|E
#define CHw				CHBLANK
#define CHx				CHBLANK
#define CHy				B|C|D|F|G
#define CHz				A|B|E|D
//==============================================================
// Section: Exported Variables
//==============================================================

//==============================================================
// Section: Exported Functions
//==============================================================
#if		0
//========================================================
void Ht1621_Init(void);
void LCD_display(unsigned int temp_number);		
//========================================================
#endif
//========================================================
#if		1
//========================================================
void Ht1621_Init(void);
void Ht1621_OnOff(bit bOnOff);
void Ht1621_writedata(unsigned char commandcode,unsigned char p_data,bit num);
//void Lprintf(unsigned char *buf,unsigned char LightNum,unsigned char*string,const char* st,...);
//========================================================
#endif
//==============================================================
// Section: End Of file
//==============================================================
#endif
