//Define to prevent recursive inclusion=========================
#ifndef gpio_H
#define	gpio_H
//==============================================================
// Section: Included Files
//==============================================================

//==============================================================
// Section: Exported Constants
//==============================================================
#define	GPIO_MODE_QUASI			0
#define	GPIO_MODE_PUSHPULL		1
#define	GPIO_MODE_INPUT			2
#define	GPIO_MODE_OPENDRAIN		3

#define	PullUp					0
#define	PullDown				1

#define	Port0					0
#define	Port1					1
#define	Port2					2
#define	Port3					3
#define	Port4					4
#define	Port5					5

#define PIT0					0
#define PIT1					1
#define PIT2					2
#define PIT3					3
#define PIT4					4
#define PIT5					5
#define PIT6					6
#define PIT7					7

#define LOW     				0
#define HIGH    				1
#define FALLING 				0
#define RISING  				1
#define BOTH    				2
#define LEVEL					0
#define EDGE					1
//==============================================================
// get/set nKey_Assessibility aliases
#define nKey_Memory_SetHigh()			do { P14 = 1; } while(0)
#define nKey_Memory_SetLow()			do { P14 = 0; } while(0)
#define nKey_Memory_Toggle()			do { P14 = ~P14; } while(0)
#define nKey_Memory_GetValue()			P14
// get/set nKey_Measure aliases
#define nKey_Measure_SetHigh()			do { P46 = 1; } while(0)
#define nKey_Measure_SetLow()			do { P46 = 0; } while(0)
#define nKey_Measure_Toggle()			do { P46 = ~P46; } while(0)
#define nKey_Measure_GetValue()			P46
// get/set nKey_OnOff aliases
#define nKey_BUZZER_SetHigh()			do { P15 = 1; } while(0)
#define nKey_BUZZER_SetLow()			do { P15 = 0; } while(0)
#define nKey_BUZZER_Toggle()			do { P15 = ~P15; } while(0)
#define nKey_BUZZER_GetValue()			P15
// get/set nKey_Assessibility aliases
#define nKey_OnOff_SetHigh()			do { P16 = 1; } while(0)
#define nKey_OnOff_SetLow()				do { P16 = 0; } while(0)
#define nKey_OnOff_Toggle()				do { P16 = ~P16; } while(0)
#define nKey_OnOff_GetValue()			P16
// get/set EN_GREEN aliases
#define EN_GREEN_SetHigh()				do { P36 = 1; } while(0)
#define EN_GREEN_SetLow()				do { P36 = 0; } while(0)
#define EN_GREEN_Toggle()				do { P36 = ~P36; } while(0)
#define EN_GREEN_GetValue()				P36
// get/set EN_RED aliases
#define EN_RED_SetHigh()				do { P36 = 1; } while(0)
#define EN_RED_SetLow()					do { P36 = 0; } while(0)
#define EN_RED_Toggle()					do { P36 = ~P36; } while(0)
#define EN_RED_GetValue()				P36
// get/set EN_Detection aliases
#define EN_Detection_SetHigh()			do { P30 = 1; } while(0)
#define EN_Detection_SetLow()			do { P30 = 0; } while(0)
#define EN_Detection_Toggle()			do { P30 = ~P30 } while(0)
#define EN_Detection_GetValue()			P30
// get/set EN_Buzzer aliases
#define EN_Buzzer_SetHigh()				do { P03 = 1; } while(0)
#define EN_Buzzer_SetLow()				do { P03 = 0; } while(0)
#define EN_Buzzer_Toggle()				do { P03 = ~P03; } while(0)
#define EN_Buzzer_GetValue()			P03
//==============================================================
// Section: Exported Variables
//==============================================================

//==============================================================
// Section: Exported Functions
//==============================================================
void GPIO_SetMode(unsigned char u8Port, unsigned char u8PinMask, unsigned char u8Mode);
void GPIO_Pull_Enable(unsigned char u8Port, unsigned char u8PinMask, unsigned char u8PullMode);
void GPIO_Pull_Disable(unsigned char u8Port, unsigned char u8PinMask, unsigned char u8PullMode);
//==============================================================
void GPIO_EnableInt(		unsigned char u8PIT,
							unsigned char u8IntStatus,	unsigned char u8IntMode,
							unsigned char u8Port,		unsigned char u8PinMask);
//==============================================================
// Section: End Of file
//==============================================================
#endif
