//Define to prevent recursive inclusion=========================
#ifndef sys_H
#define	sys_H
//==============================================================
// Section: Included Files
//==============================================================

//==============================================================
// Section: Exported Constants
//==============================================================
//TIMER1_FSYS;	1/1		//TIMER1_FSYS_DIV12;	1/12
#define	TH1_INIT	((unsigned char)((65536-(1000/1*(24000000/1000000)))>>8))
#define	TL1_INIT	((unsigned char)((65536-(1000/1*(24000000/1000000)))&0xFF))
//==============================================================
#define	FSYS_HXT	0
#define	FSYS_LXT	1
#define	FSYS_HIRC	2
#define	FSYS_LIRC	3
#define	FSYS_ECLK	4
//==============================================================
#define SET_BIT0              0x01
#define SET_BIT1              0x02
#define SET_BIT2              0x04
#define SET_BIT3              0x08
#define SET_BIT4              0x10
#define SET_BIT5              0x20
#define SET_BIT6              0x40
#define SET_BIT7              0x80
#define SET_BIT8              0x0100
#define SET_BIT9              0x0200
#define SET_BIT10             0x0400
#define SET_BIT11             0x0800
#define SET_BIT12             0x1000
#define SET_BIT13             0x2000
#define SET_BIT14             0x4000
#define SET_BIT15             0x8000

#define CLR_BIT0              0xFE
#define CLR_BIT1              0xFD
#define CLR_BIT2              0xFB
#define CLR_BIT3              0xF7
#define CLR_BIT4              0xEF
#define CLR_BIT5              0xDF
#define CLR_BIT6              0xBF
#define CLR_BIT7              0x7F
                              
#define CLR_BIT8              0xFEFF
#define CLR_BIT9              0xFDFF
#define CLR_BIT10             0xFBFF
#define CLR_BIT11             0xF7FF
#define CLR_BIT12             0xEFFF
#define CLR_BIT13             0xDFFF
#define CLR_BIT14             0xBFFF
#define CLR_BIT15             0x7FFF
//==============================================================
#define PIT0					0
#define PIT1					1
#define PIT2					2
#define PIT3					3
#define PIT4					4
#define PIT5					5
#define PIT6					6
#define PIT7					7

#define LOW     				0
#define HIGH    				1
//==============================================================
// get/set nKey_Assessibility aliases
#define nKey_TEMP_OBJ_GetValue()		P16
#define nKey_BUZZER_GetValue()			P15
#define nKey_Memory_GetValue()			P14
#define nKey_Measure_GetValue()			P46
// get/set EN_GREEN aliases
#define EN_GREEN_SetHigh()				do { SFRS = 0x00; P5 |= SET_BIT2; } while(0)
#define EN_GREEN_SetLow()				do { SFRS = 0x00; P5 &= ~SET_BIT2; } while(0)
// get/set EN_RED aliases
#define EN_RED_SetHigh()				do { SFRS = 0x00; P5 |= SET_BIT3; } while(0)
#define EN_RED_SetLow()					do { SFRS = 0x00; P5 &= ~SET_BIT3; } while(0)
// get/set EN_Detection aliases
#define EN_Detection_SetHigh()			do { P30 = 1; } while(0)
#define EN_Detection_SetLow()			do { P30 = 0; } while(0)
#define EN_Detection_Toggle()			do { P30 = ~P30 } while(0)
#define EN_Detection_GetValue()			P30
// get/set EN_Buzzer aliases
#define EN_Buzzer_SetHigh()				do { P03 = 1; } while(0)
#define EN_Buzzer_SetLow()				do { P03 = 0; } while(0)
#define EN_Buzzer_Toggle()				do { P03 = ~P03; } while(0)
#define EN_Buzzer_GetValue()			P03
//==============================================================
// Section: Exported Variables
//==============================================================

//==============================================================
// Section: Exported Functions
//==============================================================
void SYSTEM_Initialize(void);
void Timer0_Delay(		unsigned long	u32SYSCLK,
						unsigned int	u16CNT,
						unsigned int	u16DLYUnit);
//==============================================================
// Section: End Of file
//==============================================================
#endif
