// Copyright(c) 2019 Nuvoton Technology Corp. All rights reserved.                                         */

// Nuvoton Technoledge Corp. 
// Website: http://www.nuvoton.com
// E-Mail : MicroC-8bit@nuvoton.com
// Date   : Apr/21/2019
//========================================================


//========================================================
// Section: Included Files
//========================================================
#include "../../../main.h"
#include <intrins.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <STDARG.H>
//========================================================
// Section: Macro Declarations
//========================================================
sbit Ht1621_WR	= P2^0;
sbit Ht1621_DATA= P2^1;
sbit Ht1621_CS	= P4^0;
sbit Ht1621_RD	= P4^1;		//add by lichi
//========================================================
#if		0
//========================================================
const unsigned char DIGIST_CODE[]={0x5f,0x06,0x6b,0x2f,0x36,0x3d,0x7d,0x07,0x7f,0x3f};
//      COM4     2  3  4     1  2  3  4
//               E  G  F     D  C  B  A
//0              1  0  1     1  1  1  1
//1              0  0  0     0  1  1  0
//2              1  1  0     1  0  1  1
//3              0  1  0     1  1  1  1
//4              0  1  1     0  1  1  0
//5              0  1  1     1  1  0  1
//6              1  1  1     1  1  0  1
//7              0  0  0     0  1  1  1
//8              1  1  1     1  1  1  1
//9              0  1  1     1  1  1  1
//========================================================
// Function		: Ht1621_Write_Cmd
// Function API : GPIO Pull up or Pull down enable setting
// param[in]	: 
// command_8bit	: 
// return		: none
// note			: none
// example		: Ht1621_Write_Cmd(0x01);
//========================================================
void Ht1621_Write_Cmd(unsigned char command_8bit)
{
	//========================================================
	unsigned short serial_data;
	unsigned char i;
	//========================================================
	Ht1621_WR = HIGH; 
	Ht1621_CS = LOW;
	//========================================================
	serial_data = 0x400 | command_8bit;//3bit ID 100 first, then 9bit command value
	serial_data<<=5;                   //LSB = 0;
	//========================================================
	for(i=0;i<12;i++)                                            //3λID
	{
		//========================================================
		Ht1621_WR = LOW;
		_nop_();
		//========================================================
		if( serial_data&0x8000 )
			Ht1621_DATA = HIGH;
		else
			Ht1621_DATA = LOW;
		//========================================================
		_nop_();
		Ht1621_WR = HIGH;
		_nop_();
		//========================================================
		serial_data<<=1;
		//========================================================
	}
	//========================================================
	Ht1621_CS = HIGH;
	//========================================================
}
//========================================================
void Ht1621_Write_Data(unsigned char addr_6bit,unsigned char value_4bit)//d0,d1,d2,d3
{
	unsigned short serial_data;
	unsigned char i;
	Ht1621_WR = HIGH; 
	Ht1621_CS = LOW;
	//3bit ID 101 first, then 6bit address, then 4bit value(d0,d1,d2,d3)
	serial_data = (	(unsigned short)0x5<<10) | 
					((unsigned short)addr_6bit<<4) | value_4bit;
	serial_data<<=3;		//LSB = 0;

	for(i=0;i<13;i++)		//3λID
	{
		Ht1621_WR = LOW;
		_nop_();
		if( serial_data&0x8000 )
		Ht1621_DATA = HIGH;
		else
		Ht1621_DATA = LOW;
		_nop_();
		Ht1621_WR = HIGH;
		_nop_();
		serial_data<<=1;
	}
	Ht1621_CS = HIGH;		
}
//========================================================
// : 򿪻߹رLCD1Ϊ򿪣0Ϊر
// ӿ: 
//========================================================
void Ht1621_OnOff(bit bOnOff)
{
	//========================================================
	if( bOnOff )
		Ht1621_Write_Cmd(0x03);	//LCD, LCDƫѹ
	else
		Ht1621_Write_Cmd(0x02);	//رLCD, رLCDƫѹ	
	//========================================================
}
//========================================================
//ԭ: void initlcd(void);
//: ʼ
//========================================================
void Ht1621_Init(void)
{
	//========================================================
	Ht1621_RD = HIGH;
	Ht1621_CS = HIGH;
	//========================================================
	Ht1621_Write_Cmd(0x01);		//ϵͳ
	Ht1621_Write_Cmd(0x03);		//EnableLCD
//	Ht1621_Write_Cmd(0x02);		//رLCD
	Ht1621_Write_Cmd(0x08);		//ر
	Ht1621_Write_Cmd(0x05);		//WDT DIS
	Ht1621_Write_Cmd(0x18);		//ϵͳʱԴѡΪƬRC
	Ht1621_Write_Cmd(0x29);		//LCD 1/3ƫѹ4COM
	Ht1621_Write_Cmd(0xe3);		//ͨģʽ	
	//========================================================
}
//========================================================
// ԭ: void LCD_display
// : Һʾ
// ӿ: 
//	body_temp		: ºлʾ1Ϊʾ£0Ϊʾ
//	battery			: صʾ0Ϊո1Ϊ12Ϊ23Ϊ3
//	face			: ЦͿлʾ1ΪЦ0Ϊ
//	voice			: ʾ1Ϊ0Ϊ
//	centigrade		: ϶Ⱥͻ϶лʾ1Ϊ϶ȣ0Ϊ϶
//	memory_number	: λʾ00~99
//	temp_number		: ¶4λʾ0000~9999
//========================================================
void LCD_display(unsigned int temp_number)
{
	//========================================================
	unsigned char value_4bit;
	//==PIN1ʾ==============================================
//	value_4bit = ((unsigned char)(body_temp ==1)<<2)|((unsigned char)(battery >1)<<1)|(unsigned char)(battery ==1);
	Ht1621_Write_Data(BAT_SEG_ADDR, 0);//value_4bit);//DIGIST_CODE
	//==PIN2,PIN3ʾ=========================================
	value_4bit = DIGIST_CODE[(temp_number/1000)%10];
	Ht1621_Write_Data(DIGIST1H_SEG_ADDR,value_4bit>>4);
	Ht1621_Write_Data(DIGIST1L_SEG_ADDR,value_4bit&0xf);
	//==PIN4,PIN5ʾ=========================================
	value_4bit = DIGIST_CODE[(temp_number/100)%10];
	Ht1621_Write_Data(DIGIST2H_SEG_ADDR,value_4bit>>4);
	Ht1621_Write_Data(DIGIST2L_SEG_ADDR,value_4bit&0xf);
	//==PIN6,PIN7ʾ=========================================
	value_4bit = DIGIST_CODE[(temp_number/10)%10];
	Ht1621_Write_Data(DIGIST5H_SEG_ADDR,value_4bit>>4);
	Ht1621_Write_Data(DIGIST5L_SEG_ADDR,value_4bit&0xf);	
	//==PIN8,PIN9ʾ=========================================
	value_4bit = DIGIST_CODE[temp_number%10];
	Ht1621_Write_Data(DIGIST6H_SEG_ADDR,value_4bit>>4);
	Ht1621_Write_Data(DIGIST6L_SEG_ADDR,value_4bit&0xf);	
	//==PIN10,PIN11ʾ=======================================
	//==PIN12,PIN13ʾ=======================================
	//==PIN14ʾ=============================================
	//========================================================
	Ht1621_Write_Data(DIGIST3H_SEG_ADDR,0);
	Ht1621_Write_Data(DIGIST3L_SEG_ADDR,0);
	Ht1621_Write_Data(DIGIST4H_SEG_ADDR,0);
	Ht1621_Write_Data(DIGIST4L_SEG_ADDR,0);	
	Ht1621_Write_Data(DEGREE_SEG_ADDR,0);
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
#if		1
//========================================================
// : Ht1621дID
// ӿ: void Ht1621_WriteCmdId(unsigned char ucCmdId);
//========================================================
void Ht1621_WriteCmdId(unsigned char ucCmdId)
{
	//========================================================
	unsigned char i;
	//========================================================
	Ht1621_WR = HIGH; 
	Ht1621_CS = LOW;
	//========================================================
	for(i=0;i<3;i++)			//3λID		0x80/0xA0  д
	{
		//========================================================
		Ht1621_WR = LOW;
		_nop_();
		//========================================================
		if( ucCmdId&0x80 )
			Ht1621_DATA = HIGH;
		else
			Ht1621_DATA = LOW;
		_nop_();
		//========================================================
		Ht1621_WR = HIGH;
		_nop_();
		//========================================================
		ucCmdId = ucCmdId<<1;
		//========================================================
	}
	//========================================================
}
//========================================================
// : Ht1621дֵ
// ӿ: void Ht1621_WriteCmdVal(unsigned char ucCmdVal);
//========================================================
void Ht1621_WriteCmdVal(unsigned char ucCmdVal)
{
	//========================================================
	unsigned char i;
	//========================================================
	Ht1621_WriteCmdId(0x80);	//3bit ID		0x80/0xA0 д
	//========================================================
	for(i=0;i<8;i++)			//8λֵ
	{
		//========================================================
		Ht1621_WR = LOW;
		_nop_();
		//========================================================
		if( ucCmdVal&0x80 )
			Ht1621_DATA = HIGH;
		else
			Ht1621_DATA = LOW;
		//========================================================
		_nop_();
		Ht1621_WR = HIGH;
		_nop_();
		//========================================================
		ucCmdVal = ucCmdVal<<1;
		//========================================================
	}
	//========================================================
	Ht1621_WR	= LOW;			//1λ޹λ
	_nop_();
	Ht1621_DATA = LOW;
	_nop_();
	Ht1621_WR	= HIGH;
	_nop_();
	//========================================================
	Ht1621_CS = HIGH;
	//========================================================
}
//========================================================
//ԭ: void Ht1621_writedata(uchar commandcode,uchar p_data,bit num);
//: деַݵHt1621
//========================================================
void Ht1621_writedata(unsigned char commandcode,unsigned char p_data,bit num)
{
	//========================================================
	unsigned char	i;
	//========================================================
	Ht1621_WriteCmdId(0xA0);				//3bit ID		0x80/0xA0 д
	//========================================================
	for(i=0;i<6;i++)						//ַ6λ
	{
		//========================================================
		Ht1621_WR = LOW;
		_nop_();
		//========================================================
		Ht1621_DATA = (bit)(commandcode&0x20);	
		_nop_();
		//========================================================
		Ht1621_WR = HIGH;
		_nop_();
		//========================================================
		commandcode<<=1;
		//========================================================
	}
	//========================================================
	for(i=0;i<(num?0x8:0x4);i++)			//D7  D6  D5  D4  D3  D2  D1  D0
	{		//:ߵַCOM4,COM3,COM2,COM1	͵ַCOM4COM3COM2COM1
		//========================================================
		Ht1621_WR = LOW;
		_nop_();
		//========================================================
		Ht1621_DATA = (bit)(p_data&0x01);
		_nop_();
		//========================================================
		Ht1621_WR = HIGH;
		_nop_();
		//========================================================
		p_data>>=1;
		//========================================================
	}
	//========================================================
	Ht1621_DATA = HIGH;
	Ht1621_CS	= HIGH;
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
//ԭ: void Ht1621_writecommand (uchar commandcode);
//: дһֽݵHt1621
//========================================================
void Ht1621_writecommand(bit commandcode)
{
	//========================================================
	Ht1621_CS	= LOW;
	//========================================================
	_nop_();
	Ht1621_DATA = HIGH;				//˿ø 1
	Ht1621_WR	= LOW;
	_nop_();
	Ht1621_WR	= HIGH;
	//========================================================
	_nop_();
	Ht1621_DATA = LOW;				//˿ø 0
	Ht1621_WR	= LOW;
	_nop_();
	Ht1621_WR	= HIGH;
	//========================================================
	_nop_();
	Ht1621_DATA = commandcode;		//0/1  д
	Ht1621_WR	= LOW;
	_nop_();
	Ht1621_WR	= HIGH;
	//========================================================
}
//========================================================
// : 
// ӿ: 
//========================================================
void Ht1621_Beep(bit bOnOff)
{
	Ht1621_writecommand(bOnOff?0x09:0x08);
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
//ԭ: void Ht1621_Init(void);
//: ʼ
//========================================================
void Ht1621_Init(void)
{
	//========================================================
	Ht1621_RD = HIGH;
	Ht1621_CS = HIGH;
	Ht1621_WR = HIGH; 
	Ht1621_CS = LOW;
	//========================================================
	Ht1621_WriteCmdVal(0x01); 	//ϵͳ
	Ht1621_WriteCmdVal(0x03); 	//Enable LCD
	Ht1621_WriteCmdVal(0x05); 	//WDT DIS
	Ht1621_WriteCmdVal(0x18); 	//ϵͳʱԴѡΪƬRC
	Ht1621_WriteCmdVal(0x29); 	//LCD 1/3ƫѹ4COM
	Ht1621_WriteCmdVal(0x60);
	Ht1621_WriteCmdVal(0xe3); 	//ͨģʽ	
	//========================================================
//	Ht1621_Beep(OFF); 			//ر
//	Ht1621_OnOff(OFF); 			//Disable LCD
	//========================================================
}
//========================================================
// : 
// ӿ: 
//========================================================
void Ht1621_OnOff(bit bOnOff)
{
	//========================================================
	if( bOnOff )
		Ht1621_WriteCmdVal(0x03);	//LCD, LCDƫѹ
	else
		Ht1621_WriteCmdVal(0x02);	//رLCD, رLCDƫѹ
	//========================================================
}
//========================================================
#endif
//========================================================
#if		0
//========================================================
//ԭ: void Ht1621_Driver(void);
//: Ht1621
//ѵ3ֵstĸʽLcd[], *stringֵLcd[]
//========================================================
void Lprintf(unsigned char *buf,unsigned char LightNum,unsigned char*string,const char* st,...) 
{
	//========================================================
	unsigned char	i;
	unsigned char	j;
	//========================================================
	va_list		t;			//(STDARG.hж壩1ָָt
	//========================================================
	va_start(t,st);			//tָstǸ
	vsprintf(buf,st,t);	//STDIO.hж;tֵst涨ĸʽת
							//ֵASCIILcdbuf[],Lcdbuf[0]ʼ
	va_end(t);				//ָt	    //ÿԪط1ַ
	//========================================================
	i = 0;
	j = 0;
	//========================================================
	do
	{
		if(isalnum(buf[i]))        // char_temp='A-Z''a-z''0-9'
			buf[j++]=buf[i++]-0x30;
		else if(buf[i]=='.')      //Сʱ,С!
		{
//			buf[j-1] |= DP;
			i++;
		}  //Iָһ;Jƶһ!
		else
			buf[j++]=buf[i++];
	}while(j<LightNum);		 ///while(i<10);
	//========================================================
	i = 0;
	//========================================================
	while(*string!='\0')         //ַ,ڽַ'FIL  3   \0'
	{
		if(isalnum(*string))        // char_temp='A-Z''a-z''0-9'
		{
			if(*string=='P') 		    // ʾ"P"	 
				buf[i++]=(*string++)-0x2F;//
			else
				buf[i++]=(*string++)-0x30;
		}
		else if(*string=='.')
		{
//			buf[i-1] |= DP;
			string++;//Iָһ;Jƶһ!
		}
		else
			buf[i++]=(*string++);//" ","-"
	}
	//========================================================
}
//========================================================
#endif
//========================================================
#endif
//========================================================
// Function	 	: 
// Function API	: 
// return		: None
//========================================================
