//========================================================
// Copyright(c) 2019 Nuvoton Technology Corp. All rights reserved.                                         */

// Nuvoton Technoledge Corp. 
// Website: http://www.nuvoton.com
// E-Mail : MicroC-8bit@nuvoton.com
// Date   : Apr/21/2019
//========================================================


//========================================================
// Section: Included Files
//========================================================
#include "../../../main.h"
//========================================================
// Section: Macro Declarations
//========================================================

//========================================================
#if		1
//========================================================
// Function 	: Timer1_ISR
// Function API : TIMER 1 interrupt subroutine
// param[in]	: None
// note			: None
// return		: None
// details		: None
//========================================================
void Timer1_ISR(void) interrupt 3        // Vector @  0x1B
{
	//========================================================
	TCON &= CLR_BIT7;		//clr_TCON_TF1;
	//========================================================
	TH1 = TH1_INIT;
	TL1 = TL1_INIT;
	//========================================================
	stMainInfo.ucCount++;
	//========================================================
	if( stMainInfo.ucCount%Timer_Read_ms==0 )
	{
		//========================================================
		stMainInfo.ucWork_nmS |= Timer_Read;
		//========================================================
	}
	//========================================================
	if( stMainInfo.ucCount%Timer_Blink_ms==0 )
	{
		//========================================================
		if( (Timer_Blink&stMainInfo.ucWork_nmS)==Timer_Blink )
			stMainInfo.ucWork_nmS &= ~Timer_Blink;
		else
			stMainInfo.ucWork_nmS |= Timer_Blink;
		//========================================================
	}
	//========================================================
	if( stMainInfo.ucCount%Timer_Vbat_ms==0 )
	{
		//========================================================
		stMainInfo.ucWork_nmS |= Timer_Vbat;
		//========================================================
	}
	//========================================================
	if( stMainInfo.ucCount%Timer_BacklightOFF_ms==0 )
	{
		//========================================================
		stMainInfo.ucWork_nmS |= Timer_BacklightOFF;
		//========================================================
	}
	//========================================================
	if( stMainInfo.ucCount%Timer_DisplayOFF_ms==0 )
	{
		//========================================================
		stMainInfo.ucWork_nmS |= Timer_DisplayOFF;
		//========================================================
	}
	//========================================================
	if( stMainInfo.ucCount>=Timer_Sleep_ms )
	{
		//========================================================
		stMainInfo.ucCount = 0;
		stMainInfo.ucWork_nmS |= Timer_Sleep;
		//========================================================
	}
	//========================================================
	if( stMainInfo.bBuzzer==Buzzer_Event )
	{
		//========================================================
		stMainInfo.ucBuzzer_Count++;
		if( stMainInfo.bErr==Err_Event )
		{
			//========================================================
			if( stMainInfo.ucBuzzer_Count>=Timer_Buzzer_Err_twoDiDi_ms )
			{
				//========================================================
				P03 = 0;	//EN_Buzzer_SetLow();
				stMainInfo.bErr		= Err_Event_NO;
				stMainInfo.bBuzzer	= Buzzer_Event_NO;
				stMainInfo.ucBuzzer_Count = 0;
				//========================================================
			}
			else if( stMainInfo.ucBuzzer_Count>=Timer_Buzzer_Err_ms )
			{
				//========================================================
				P03 = 1;	//EN_Buzzer_SetHigh();
				//========================================================
			}
			else if( stMainInfo.ucBuzzer_Count>=Timer_Buzzer_ms )
			{
				//========================================================
				P03 = 0;	//EN_Buzzer_SetLow();
				//========================================================
			}
			//========================================================
		}
		else
		{
			//========================================================
			if( stMainInfo.ucBuzzer_Count>=Timer_Buzzer_ms )
			{
				//========================================================
				P03 = 0;	//EN_Buzzer_SetLow();
				stMainInfo.bBuzzer = Buzzer_Event_NO;
				stMainInfo.ucBuzzer_Count = 0;
				//========================================================
			}
			//========================================================
		}
		//========================================================
	}
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
// Function 	: PinInterrupt_ISR
// Function API : Port0~5 Interrupt Subroutine
// param[in]	: None
// note			: None
// return		: None
// details		: PIF 0~7 declair in GPIO_EnableInt interrupt.
//========================================================
void PinInterrupt_ISR(void) interrupt 7
{
	//========================================================
	PIF = 0;		//clr pin interrupt flag
	//========================================================
	if( nKey_Measure_GetValue()==0 )
	{
		//========================================================
		Timer0_Delay(24000000,1,1000);
		//========================================================
		if( nKey_Measure_GetValue()==0 )
		{
			//========================================================
			Timer0_Delay(24000000,1,1000);
			//========================================================
			while( nKey_Measure_GetValue()==0 )
				Timer0_Delay(24000000,10,1000);
//				WKCON &= ~SET_BIT3;
			//========================================================
			EN_Detection_SetLow();
			ADCCON1 |= 0x01;			// Enable ADC
			EIE0 &= 0xFD;				// EPI@bit1	Disable pin interrupt
			EX0 = 0;					// Disable int0 interrupt
			//========================================================
			stADCInfo.ADC_Read_Count= 0;
			stADCInfo.ADC_Mode		= AD_Wait_Mode;
			stMainInfo.bADC_Handler = ADC_Handler_Event;
			//========================================================
			if( stMainInfo.ucWork_Mode==Test_Sleep_Mode )
				stMainInfo.ucWork_Mode = Test_Thermometry_Mode;
			else
				stMainInfo.ucWork_Mode = Thermometry_Mode;
			//========================================================
		}
		else
		{
			//========================================================
			stMainInfo.ucCount = 0;
			stMainInfo.ucWork_nmS |= Timer_Sleep;
			//========================================================
		}
		//========================================================
	}
	else
	{
		//========================================================
		stMainInfo.ucCount = 0;
		stMainInfo.ucWork_nmS |= Timer_Sleep;
		//========================================================
	}
	//========================================================
}
//========================================================
#endif
//========================================================
#if		0
//========================================================
// Function 	: Timer0_ISR
// Function API : TIMER 0 interrupt subroutine
// param[in]	: None
// note			: None
// return		: None
// details		: None
//========================================================
void Timer0_ISR(void) interrupt 1        // Vector @  0x0B
{
	//========================================================
	TCON &= CLR_BIT5;		//clr_TCON_TF0;
	//========================================================
}
//========================================================
// Function 	: Timer2_ISR
// Function API : TIMER 2 interrupt subroutine
// param[in]	: None
// note			: None
// return		: None
// details		: None
//========================================================
void Timer2_ISR(void) interrupt 5        // Vector @  0x2B
{
	//========================================================
	T2CON &= CLR_BIT7;		//clr_T2CON_TF2;
	//========================================================
}
//========================================================
// Function 	: Timer3_ISR
// Function API : TIMER 3 interrupt subroutine
// param[in]	: None
// note			: None
// return		: None
// details		: None
//========================================================
void Timer3_ISR(void) interrupt 16        // Vector @  0x83
{
	//========================================================
	T3CON &= CLR_BIT4;		//clr_T3CON_TF3;
	//========================================================
}
//========================================================
#endif
//========================================================
// Function		: 
// Function API	: 
// return		: None
//========================================================
