//========================================================
// Copyright(c) 2019 Nuvoton Technology Corp. All rights reserved.                                         */

// Nuvoton Technoledge Corp. 
// Website: http://www.nuvoton.com
// E-Mail : MicroC-8bit@nuvoton.com
// Date   : Apr/21/2019
//========================================================


//========================================================
// Section: Included Files
//========================================================
#include "../../../main.h"
//========================================================
// Section: Macro Declarations
//========================================================

//========================================================
#if		0
//========================================================
#define MFP1          1
#define MFP2          2
#define MFP3          3
#define MFP4          4
#define MFP5          5
#define MFP6          6
#define MFP7          7
#define MFP8          8
#define MFP9          9
#define MFP10          10
#define MFP11          11
#define MFP12          12
#define MFP13          13
#define MFP14          14
#define MFP15          15
//========================================================
void Hardware_Init(void)
{
  /*
  PnM1.x PnM2.x I/O Type
    0 0 Quasi-bidirectional
    0 1 Push-pull
    1 0 Input-only (high-impedance)
    1 1 Open-drain
  */
  /* GPIO Multi-Function Select
     P0MF10 ------ P0  Multi-Function Select of P01/P00
  */
  /*
  Input Type
  PnS[7:0] P0 Schmitt triggered input
   0 = TTL level input of Pn.x.
   1 = Schmitt triggered input of Pn.x.
  
  Output Slew Rate Control
  PnSR[7:0] P0.n slew rate
  0 = Pn.x normal output slew rate.
  1 = Pn.x high-speed output slew rate. 
  
  Pull-Up Resister Control         ----only effect when GPIO setting as input mode.
  PnUP[7:0] P0.n pull-up enable
  0 = Pn.x pull-up Disabled.
  1 = Pn.x pull-up Enabled.
  
  Pull-Down Resister Control       ----only effect when GPIO setting as input mode.
  PnDW[7:0] P0.n pull-down enable
  0 = Pn.x pull-down Disabled.
  1 = Pn.x pull-down Enabled.
  */
  //---------P5.2 act as RXD0,P5.3 act as TXD0
  //Serial port 0 RX/TX pin exchange!!!!!!!!!!!!!!!!!!!!
  //half-duplex communication
  //Mode 3
  //SM0_1 / SM1_1(S1CON[7:6])=11
  //AUXR1 ?Auxiliary Register 1.bit0    UART0PX :Serial port 0 RX/TX pin exchange
  /*
  Serial port 0 RX/TX pin exchange
  0 = Assign UART0 RXD to multiple I/O pin RXD
      UART0 TXD to multiple I/O pin TXD
  1 = Assign UART0 RXD to multiple I/O pin TXD
      UART0 TXD to multiple I/O pin RXD
  Note: that Pin direction is controlled by I/O type of relative pin.
   RXD/TXD will exchange immediately once setting or clearing this bit. User
   should take care of not exchanging pins during transmission or receiving. Or it
   may cause unpredictable situation and no warning alarms.
  */
  //-------------system clock config-------------------------
  //Note that after the ML51 is powered, HIRC and LIRC will be both enabled and HIRC is default selected as the system clock source.
  //24 MHz Internal Oscillator
  //TA protected???????##########
  IE = 0;
  SFRS = 0;//page0
  CKEN =             //====Clock Enable (TA protected)====
         (0<<7)|       //EHXTEN:   External High-speed crystal/resonator enable
                       //0:external crystal/resonator 4-24 MHz Disabled,P5.2 and P5.3 work as general purpose I/O or other functions if ECLKEN set to 0.
         (0<<6)|       //ELXTEN:External Low-speed crystal/resonator enable
                       //0:Low-speed external crystal/resonator 32.768 kHz Disabled, P5.4 and P5.5 work as general purpose I/O or other functions.
         (1<<5)|       //HIRCEN: High-speed internal oscillator 24 MHz enable
         (0<<4)|       //LIRCEN: Low speed internal oscillator 38.4 kHz enable
         (0<<3)|       //ECLKEN: External Clock Input enable
         (1<<2)|       //Reserved, value after reset is 1
         (0<<1)|       //Reserved, value after reset is 0
         0;            //CKSWTF: Clock switch fault flag
  //Once user switches the system clock source to an enabled but still instable one, the hardware will wait for
  //stabilization of the target clock source and then switch to it in the background.
  CKSWT =            //====CKSWT: Clock Switch (TA protected)====
                     //
         (0<<7)|       //HXTST:High speed external crystal/resonator 4 MHz to 24 MHz status 
                       //1 = High speed external crystal/resonator is enabled and stable.
         (0<<6)|       //LXTST:Low speed external crystal/resonator 32.768 kHz status
                       //1 = Low speed external crystal/resonator is enabled and stable.
         (1<<5)|       //HIRCST: High-speed internal oscillator 24 MHz status    1 = High-speed internal oscillator is enabled and stable.
         (0<<4)|       //LIRCST: Low speed internal oscillator 38.4 kHz status   1 = Low speed internal oscillator is enabled and stable.
         (0<<3)|       //ECLKST: External clock input status.    1 = External clock input is enabled and stable.
         0;            //OSC[2:0]: This field selects the system clock source.
                       //00x = Internal 24 MHz oscillator. Defaul value accoding to HIRCEN(CKEN.5) enabled.
  CKDIV = 0;         //CKDIV[7:0]:Clock Divider
                       //Fsys = Fosc/(2*CKDIV),while CKDIV = 01H to FFH;  Fsys = Fosc while CKDIV = 00H.
  //-------------GPIO Input/Output---------------------------
  /*
  PnM1.x PnM2.x I/O Type
    0 0 Quasi-bidirectional
    0 1 Push-pull
    1 0 Input-only (high-impedance)
    1 1 Open-drain
         (1<<7)|       //
         (0<<6)|       //
         (0<<5)|       //
         (0<<4)|       //
         (0<<3)|       //
         (0<<2)|       //
         (0<<1)|       //
         0;            //   
  */
  SFRS = 1;//page1
  //P0:--/--/--/--/NC/SPI_CLK/SPI_MISO/SPI_MOSI
  P0M1 = (1<<7)|(1<<6)|(1<<5)|(1<<4) | (1<<3)|(0<<2)|(1<<1)| 0;//P0.3:NC,P0.2:Push-pull(SPI0CLK),P0.1:Input(SPI0MISO),P0.0:Push-pull(SPI0MOSI),
  P0M2 = (0<<7)|(0<<6)|(0<<5)|(0<<4) | (0<<3)|(1<<2)|(0<<1)| 1;//other pins:input
  P0SR = (0<<3)|(1<<2)|(0<<1)| 1;         //normal output slew rate.         1 = Pn.x high-speed output slew rate.
  P0UP = 0;         //pull-up Disabled.
  P0DW = 0xf8;      //1:pull-down Enabled, unused pin pulldown enable
  P0S = 0;          //TTL level input, NO Schmitt triggered input

  //P1:UART_RXTX/EN_POWER/WAKEUP_NB/RESET_NB/--/--/--/--
  P1M1 = (1<<7)|(0<<6)|(0<<5)|(0<<4) | (1<<3)|(1<<2)|(1<<1)| 1;//
  P1M2 = (0<<7)|(1<<6)|(1<<5)|(1<<4) | (0<<3)|(0<<2)|(0<<1)| 0;//other pins:input
  P1SR = 0;         //normal output slew rate.         1 = Pn.x high-speed output slew rate.
  P1UP = 0;         //pull-up Disabled.
  P1DW = 0x0f;      //1:pull-down Enabled, unused pin pulldown enable
  P1S = 0;          //TTL level input, NO Schmitt triggered input
  
  //P2:--/--/GREEN_LED/RED_LED/nPLAYING/MUSIC_RESET/MUSIC_PULS/Ad_Vbat
  P2M1 = (1<<7)|(1<<6)|(0<<5)|(0<<4) | (1<<3)|(0<<2)|(0<<1)| 1;
  P2M2 = (0<<7)|(0<<6)|(1<<5)|(1<<4) | (0<<3)|(1<<2)|(1<<1)| 0;
  P2SR = 0;         //normal output slew rate.
  P2UP = 0;         //pull-up Disabled.
  P2DW = (1<<7)|(1<<6)|(0<<5)|(0<<4) | (0<<3)|(0<<2)|(0<<1)| 0;      //1:pull-down Enabled, unused pin pulldown enable
  P2S = 0;          //TTL level input, NO Schmitt triggered input 
  
  //P3:--/--/--/--/--/NC/AD_TEMP/En_Adtemp   
  P3M1 = (1<<7)|(1<<6)|(1<<5)|(1<<4) | (1<<3)|(1<<2)|(1<<1)| 0;
  P3M2 = (0<<7)|(0<<6)|(0<<5)|(0<<4) | (0<<3)|(0<<2)|(0<<1)| 1;
  P3SR = 0;         //normal output slew rate.
  P3UP = 0;         //pull-up disabled.
  P3DW = (1<<7)|(1<<6)|(1<<5)|(1<<4) | (1<<3)|(1<<2)|(0<<1)| 0;      //1:pull-down Enabled, unused pin pulldown enable
  P3S = 0;          //TTL level input, NO Schmitt triggered input   
  
  //P4:--/nINT0/--/--/--/--/nSPI_SS/GPIO0(nINT1)
  P4M1 = (1<<7)|(1<<6)|(1<<5)|(1<<4) | (1<<3)|(1<<2)|(0<<1)| 1;//P4.6/nGREEN:  OD     P4.1:Push-pull(SPI0SS) others is input(10)
  P4M2 = (0<<7)|(0<<6)|(0<<5)|(0<<4) | (0<<3)|(0<<2)|(1<<1)| 0;
  P4SR = (0<<7)|(0<<6)|(0<<5)|(0<<4) | (0<<3)|(0<<2)|(0<<1)| 0;;         //normal output slew rate.
  P4UP = (1<<6);         //P4.6 PULL-UP ENABLED, OTHERS pull-up disabled.
  P4DW = (1<<7)|(0<<6)|(1<<5)|(1<<4) | (1<<3)|(1<<2)|(0<<1)| 0;      //1:pull-down Enabled, unused pin pulldown enable
  P4S = 0;          //TTL level input, NO Schmitt triggered input 
  
  //P5:--/--/--/--/NC/NC/RXD/TXD
  P5M1 = (1<<7)|(1<<6)|(1<<5)|(1<<4) | (1<<3)|(1<<2)|(0<<1)| 0;//P5.2 act as RXD0,P5.3 act as TXD0(nPLAYING,pull-up)
  P5M2 = (0<<7)|(0<<6)|(0<<5)|(0<<4) | (0<<3)|(0<<2)|(0<<1)| 0;
  P5SR = 0;         //normal output slew rate.
  P5UP = 0;         //pull-up disabled.
  P5DW = (1<<7)|(1<<6)|(1<<5)|(1<<4) | (1<<3)|(1<<2)|(0<<1)| 0;      //1:pull-down Enabled, unused pin pulldown enable
  P5S = 0;          //TTL level input, NO Schmitt triggered input 
  
  SFRS = 0;//back to page0
  //-------------GPIO Multi-Function Select------------------
  SFRS = 2;//page2
  
  P0MF10 = (MFP3<<4)|MFP3;     //P0.1:SPI0MISO            P0.0:SPI0MOSI     
  P0MF32 = (0<<4)|MFP3;        //P0.3:SPI0SS              P0.2:SPI0CLK
  P1MF76 = (MFP3<<4)|0;        //P1.7:UART0_RXD
  P2MF10 = MFP1;               //P2.0:AD5(Ad_Vbat) 
  P2MF32 = 0;
  P3MF10 = (MFP1<<4)|0;        //P3.1:AD6(AD_TEMP)  P3.0:Normal IO
  P4MF76 = (0<<4)|MFP15;           //----NO P4.7          P4.6:nINT0
  P4MF10 = (0<<4)|MFP15;           //P4.0:nINT1
  //P5MF10 = (MFP2<<4)|MFP2;   //P5.1:UART1_RXD             P5.0:UART1_TXD
  P5MF10 = (MFP14<<4)|MFP14;   //P5.1:ICE_DAT             P5.0:ICE_CLK
  
  SFRS = 0;//back to page0
  //----------uart config------------------------------------------
  //Mode3 using Timer 1 overflows as baud rate clocks
  //1 start + 8 data+ 1parity(not be checked) 
  SFRS=0;
         
  PCON = //PCON: Power Control
         (1<<7)|       //SMOD: Serial port 0 double baud rate enable
         (0<<6)|       //SMOD0: Serial port 0 framing error flag access enable.  0 = SCON.7 accesses to SM0 bit.
         (0<<5)|       //LPR: Low power run mode
         (0<<4)|       //POF: Power-on reset flag
         (0<<3)|       //GF1: General purpose flag 1
         (0<<2)|       //GF0 General purpose flag 0
         (0<<1)|       //PD Power-down mode
         0;            //IDL Idle mode
   
  SCON = //SCON :Serial Port Control (Bit-addressable)//0x50;             /*UART0 Mode1,REN=1,TI=1 */
         (0<<7)|       //SM0/FE Serial port mode select
         (1<<6)|       //SM1 SM[1:0]:serial port mode select.
         (0<<5)|       //SM2:For multiprocessor communication.  0 = Reception is always valid no matter the logic level of the 9th bit.
         (1<<4)|       //REN: Receiving enable
         (1<<3)|       //TB8: 9th transmitted bit
         (0<<2)|       //RB8: 9th received bit
         (0<<1)|       //TI: Transmission interrupt flag (his bit should be cleared manually via software.)
         0;            //RI: Receiving interrupt flag (his bit should be cleared manually via software.)

  TMOD = //Timer 0 and 1 Mode
         (0<<7)|       //GATE: Timer 1 gate control.  0 = Timer 1 will clock when TR1 is 1 regardless of nINT1 logic level.
         (0<<6)|       //C/nT: Timer 1 Counter/Timer select.  0 = Timer 1 is incremented by internal system clock.
         (1<<5)|       //M1   M[1:0]:Timer 1 mode select
         (0<<4)|       //M0   0: 13-bit Timer/Counter/1: 16-bit Timer/Counter/2: 8-bit Timer/Counter with auto-reload from TH1/3: Timer 1 halted
         (0<<3)|       //GATE: Timer 0 gate control.  0 = Timer 0 will clock when TR0 is 1 regardless of nINT0 logic level.
         (0<<2)|       //C/nT:  Timer 0 Counter/Timer select
         (1<<1)|       //M1   M[1:0]:Timer0 mode select
         0;            //M0   0: 13-bit Timer/Counter/1: 16-bit Timer/Counter/2: 8-bit Timer/Counter with auto-reload from TH0/3: TL0 as a 8-bit Timer/Counter and TH0 as a 8-bit Time

  CKCON =    //Clock Control
         (1<<7)|       //FASTWK: Fast Wakeup enable        1 = Faster Wakeup Enabled, when system wakeup from power down mode,HIRC clock stable time is about 3us.
         (0<<6)|       //PWMCKS: PWM clock source select   1 = The clock source of PWM is the overflow of Timer 1.   0 = The clock source of PWM is the system clock FSYS.
         (0<<5)|       //T1OE: Timer 1 output enable       1 = Timer 1 output Enabled from T1 pin.
         (1<<4)|       //T1M: Timer 1 clock mode select    1 = The clock source of Timer 1 is direct the system clock.
         (0<<3)|       //T0M: Timer 0 clock mode select    0 = The clock source of Timer 0 is the system clock divided by 12.
         (0<<2)|       //T0OE: Timer 0 output enable       1 = Timer 0 output Enabled from T0 pin.
         (0<<1)|       //CLOEN: System clock output enable 1 = System clock output Enabled from CLO pin.
         0;            //Reserved
  
  T3CON =        //Timer 3 Control           Serial port 0 baud rate clock source = Timer1
         (0<<7)|       //SMOD_1: Serial port 1 double baud rate enable
         (0<<6)|       //SMOD0_1: Serial port 1 framing error access enable
         (0<<5)|       //BRCK: Serial port 0 baud rate clock source      0 = Timer 1.  1 = Timer 3.
         (0<<4)|       //TF3: Timer 3 overflow flag     This bit can be set or cleared by software.
         (0<<3)|       //TR3: Timer 3 run control
         0;            //T3PS[2:0] Timer 3 pre-scalar         2^T3PS
  //TH1 = 100;//TH1 = 256 - (24000000/16/9600);//TH1 = 256 - (u32SysClock/16/u32Baudrate);            100@9600
  TH1 = 178;//19200             

  TCON =       //TCON: Timer 0 and 1 Control (Bit-addressable)
         (0<<7)|       //TF1: Timer 1 overflow flag     This bit can be set or cleared by software.
         (1<<6)|       //TR1: Timer 1 run control
         (0<<5)|       //TF0: Timer 0 overflow flag     This bit can be set or cleared by software.
         (1<<4)|       //TR0: Timer 0 run control
         (0<<3)|       //IE1: External interrupt 1 edge flag 
         (1<<2)|       //IT1: External interrupt 1 type select    0 = nINT1 is low level triggered.   1 = nINT1 is falling edge triggered.
         (0<<1)|       //IE0: External interrupt 0 edge flag
         1;            //IT0: External interrupt 0 type select    0 = nINT0 is low level triggered.   1 = nINT0 is falling edge triggered.
  //---------TMR0 for time base-------------------------------------
  TH0 = 56;   // TMR0 clock:24M/12=2M (0.5uS)  0.5uS*200=100uS
  //---------P0.0:SPI01MOSI,P0.1:SPI01MISO,P0.2:SPI01CLK,P0.3:SPI01SS
  //Write all data MSB first.  500k bit/s
  SFRS = 0;
  SPI0CR0 =   //SPInCR0: Serial Peripheral Control Register0
         (0<<7)|       //SSOE: Slave select output enable  0 = nSS functions as a general purpose I/O pin.
         (0<<6)|       //SPIEN: SPI enable                 1 = SPI function Enabled.
         (0<<5)|       //LSBFE: LSB first enable           0 = The SPI data is transferred MSB first.
         (1<<4)|       //MSTR: Master mode enable          1 = The SPI is configured as Master mode.
         (0<<3)|       //CPOL: SPI clock polarity select   0 = The SPI clock is low in idle state.
         (0<<2)|       //CPHA: SPI clock phase select      0 = The data is sampled on the first edge of the SPI clock.(rising edge while CPOL=0)
                             //The SCLK signal latches MOSI on a low to high transition.
                             //The MISO data is shifted out of the device on the falling edge of SCLK and must be clocked into a receiving device, 
                             //such as a microcontroller, on the SCLK rising edge.
         0;            //SPR[1:0]: SPI clock rate select.   
                       //These two bits select four grades of SPI clock divider. The clock rates below are illustrated under FSYS = 24 MHz condition.
                       
  SPI0SR =   //SPInSR ?Serial Peripheral Status Register
         (0<<7)|       //SPIF: SPI complete flag
         (0<<6)|       //WCOL: Write collision error flag
         (0<<5)|       //SPIOVF: SPI overrun error flag
         (0<<4)|       //MODF: Mode Fault error flag
         (1<<3)|       //DISMODF: Disable Mode Fault error detection
                           //0 = Mode Fault detection Enabled. nSS serves as input pin for Mode Fault detection disregard of SSOE.
                           //1 = Mode Fault detection Disabled. The feature of nSS follows SSOE bit.
         (1<<2)|       //DISSPIF: Disable SPI complete interrupt        1 = SPI Complete Interrupt Disabled
         (0<<1)|       //TXBFF: SPI TX Buffer Full Flag
         0;            // Rerserved 
  SFRS = 1 ;
  SPI0CR1 =   //SPInCR1: Serial Peripheral Control Register1                     
         (0<<7)|       //Reserved
         (0<<6)|       //Reserved
         (1<<5)|       //
         (1<<4)|       //SPR[3:2]: SPI clock rate select  SPR[3:0]=1100-->500k bit/s
         (0<<3)|       //TXDMAEN: SPI TX DMA enable        1 = SPI TX DMA Enabled
         (0<<2)|       //RXDMAEN: SPI RX DMA enable        1 = SPI RX DMA Enabled
         0;            //SPIS[1:0] SPI Interval time selection between adjacent bytes     3=2.5 spi clocks
  SFRS = 0;
  SPI0CR0 |= (1<<6);       //SPIEN: SPI enable                 1 = SPI function Enabled.

  
  //---------P2.2/PWM03/AD3: green led(ok led), red led????
  
  //---------AD   P2.3/PWM02/AD2:VCC_BAT_FB      P2.5/PWM00/AD0:VDD5_FB
  ADCCON0 = 
         (0<<7)|       //ADCF: ADC flag                               While this flag is 1, ADC cannot start a new converting.
         (0<<6)|       //ADCS:A/D converting software start trigger   1 = Start an A/D converting.
         (0<<4)|       //ETGSEL[1:0]:External trigger source select
         0;            //ADCHS[3:0]:A/D converting channel select   
                       //0-7:ADC_CH0-ADC_CH7
                       //1000 = VBG (Internal band-gap voltage 1.22V).  
                       //1001 = VTEMP. (Temperature Sensor).  
                       
  ADCCON1 = 
         (0<<6)|       //7:6-Reserved
         (0<<5)|       //HIE:ADC Half Done Interrupt Enable
         (0<<4)|       //CONT:ADC Continue Sampling select
         (0<<2)|       //ETGTYP[1:0]:External trigger type select
         (0<<1)|       //ADCEX:ADC external conversion trigger select   0 = A/D conversion is started only via setting ADCS bit.
         0;            //ADCEN:ADC enable     0 = ADC circuit off.  

  //----Disabled digital input at ADC channel, for better ADC result
  SFRS = 1 ;
  AINDIDS =     //1 = Disabled digital input at ADC channel n . ADC channel n is read always 0.                   
         (0<<7)|       //
         (1<<6)|       //En_Ad_Temp @P31
         (1<<5)|       //CH_AD_VBAT at P20
         (0<<4)|       //
         (0<<3)|       //
         (0<<2)|       //
         (0<<1)|       //
         0;            //VDD5_FB at P25/AD0   
         
           
  SFRS = 0;
  ADCSR = 
         (1<<7)|       //SLOW:ADC Slow Speed Selection  0:high speed 500 ksps    1:low speed 200 ksps
         (3<<4)|       //ADCDIV[2:0]: ADC clock divider    Fadc*(2^ADCDIV[2:0])= Fsystem
         (0<<3)|       //Reserved
         (0<<2)|       //CMPHIT:ADC comparator Hit Flag
         (0<<1)|       //HDONE:A/D Conversion Half Done Flag
         0;            //FDONE:A/D Conversion Full Done Flag
  ADCCON2 = (7<<1);    //ADCAQT = 7
  VRFCON = 0; //Internal VREF Disabled    
  
  //-----------------TMR2 used for Calibrating the 32kHz Clock of  ADPD188---------------------------------------------
  //24M/512 = 46.875K
  T2CON =              //C8H, All pages    reset value:0000_0000 b
          (0<<7)|      //TF2:Timer 2 overflow flag     This bit is not automatically cleared via hardware and should be cleared via software.
          (0<<2)|      //TR2:Timer 2 run control       1 = Timer 2 Enabled.
          0;           //CM/nRL2:Timer 2 compare or auto-reload mode select         0 = Auto-reload mode.
  T2MOD =              //C9H, Page 0       reset value:0000_0000 b
         (0<<7)|       //LDEN:Enable auto-reload              0:disabled auto-reload
         (7<<4)|       //T2DIV[2:0]:Timer 2 clock divider     0->7:  1/1  1/4  1/16  1/32  1/64  1/128  1/256  1/512
         (0<<3)|       //CAPCR:Capture auto-clear             0 = Timer 2 continues counting when a capture event occurs.
         (0<<2)|       //CMPCR:Compare match auto-clear       0 = Timer 2 continues counting when a compare match occurs.
         0;            //LDTS[1:0]:Auto-reload trigger select            00 = Reload when Timer 2 overflows.
  TL2 = 0;//clr TMR2
  TH2 = 0;//clr TMR2
  //---------key input  P2.4/PWM01/AD1, act as nEN_FB(output)
  
  //---------pwm     P3.0/PWM13:SW_POWER5
  
  //---------voice ic    P3.1/PWM12/AD6:rst out    P3.2/PWM11/AD7:plus out    P4.6/PWM00:nPLAYING input
  
  //-----------wake up timer----------------------------------
  WKCON =  //Self Wake-up Timer Control            
         (0<<6)|       //[7:6]:Reserved
         (0<<5)|       //WKTCK:This bit is set WKT clock source select bit. 0 = LIRC(38.4kHz)
         (0<<4)|       //WKTF:WKT overflow flag    This bit is not automatically cleared via hardware and should be cleared via software.
         (1<<3)|       //WKTR:WKT run control    1 = WKT starts running.
         6;            //WKPS[2:0]:WKT pre-scalar  000~111 = 1,4,16,64,256,512,1024,2048   6:1/1024
  RWK =  256-(38400*6/1024);   //Self Wake-up Timer Reload Byte     86H, Page 0        6һж
  //------------PIN interrupt-------------------------------------------------
  SFRS = 1;
  PICON = 0x01;          //E9H, Page 1       0 = Level triggered.  1 = Edge triggered.
  PINEN = 0x01;          //EAH, Page 1      Pin Interrupt Negative Polarity Enable.  0 = Low-level/falling edge detect Disabled. 1 = Low-level/falling edge detect Enabled.
  PIPEN = 0x0;          //EBH, Page 1      Pin Interrupt Positive Polarity Enable.   0 = High-level/rising edge detect Disabled. 1 = High-level/rising edge detect Enabled.
  PIPS0 = 
          (1<<4)|       //PSEL[2:0]  Pin interrupt channel Port select   001 = P1 PORT.
          7;            //BSEL[2:0]  Pin interrupt channel bit select    111 = Pn.7.
          
  SFRS = 0;
  PIF = 0x0;            //CAH, Page 0 C Pin Interrupt Flags
//  Voice_Ic_Reset = 1;
  EA = 1;
  ET0 = 1;   //Enable Timer 0 interrupt
  //do not interrupt but polling     EX1 = 1;   //Enable external interrupt 1
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
// Function	  	: OSCILLATOR_Initialize
// Function API : 
// param[in]	: None
// note			: None
// return		: None
// exmaple		: OSCILLATOR_Initialize();
//========================================================
void OSCILLATOR_Initialize(void)
{
	//========================================================
	SFRS = 0x00;
	//========================================================
	TA = 0xAA;
	TA = 0x55;
	CKEN |= SET_BIT5;			//step1: enable HIRC clock source run
	while((CKSWT&SET_BIT5)==0);	//step2: check ready
	//========================================================
	TA = 0xAA;
	TA = 0x55;
	CKSWT &= 0xF8;
	while((CKEN&SET_BIT0)==1);	//step4: check system clock switching OK or NG
	TA = 0xAA;
	TA = 0x55;
	CKEN &= 0x37;				//step5: enable ECLK clock source run
	//========================================================
}
//========================================================
// Function	  	: PIN_Initialize
// Function API : 
// param[in]	: None
// note			: None
// return		: None
// exmaple		: PIN_Initialize();
//========================================================
void PIN_Initialize(void)
{
	//========================================================
	SFRS = 0x01;
	//==Key_Gpio==============================================
		P1M1 |= SET_BIT4;	P1M2 &= ~SET_BIT4;	//P14_INPUT_MODE;
		P1M1 |= SET_BIT5;	P1M2 &= ~SET_BIT5;	//P15_INPUT_MODE;
		P1M1 |= SET_BIT6;	P1M2 &= ~SET_BIT6;	//P16_INPUT_MODE;
		P4M1 |= SET_BIT6;	P4M2 &= ~SET_BIT6;	//P46_INPUT_MODE;
		P1UP |= SET_BIT4 | SET_BIT5 | SET_BIT6;
		P4UP |= SET_BIT6;
		//========================================================
		PICON |= SET_BIT4;		//set_PICON_PIT4;
		PINEN |= SET_BIT4;		//set_PINEN_PINEN4;
		PIPEN &= CLR_BIT4;		//clr_PIPEN_PIPEN4;
		PIPS4 = 0x46;			//P4.6
		//==ADC_Gpio==============================================
		P2M1 |= SET_BIT3;	P2M2 &= ~SET_BIT3;	//P23_INPUT_MODE;
		P2M1 |= SET_BIT4;	P2M2 &= ~SET_BIT4;	//P24_INPUT_MODE;
		P2M1 |= SET_BIT5;	P2M2 &= ~SET_BIT5;	//P25_INPUT_MODE;
		//==Ht1621_Gpio==ģʽ=============================
		P2M1 &= ~SET_BIT0;	P2M2 |= SET_BIT0;	//P20_PUSHPULL_MODE;
		P2M1 &= ~SET_BIT1;	P2M2 |= SET_BIT1;	//P21_PUSHPULL_MODE;
		P4M1 &= ~SET_BIT0;	P4M2 |= SET_BIT0;	//P40_PUSHPULL_MODE;
		P4M1 &= ~SET_BIT1;	P4M2 |= SET_BIT1;	//P41_PUSHPULL_MODE;
		//==Function_Gpio==ģʽ===========================
		P0M1 &= ~SET_BIT3;	P0M2 |= SET_BIT3;	//P03_PUSHPULL_MODE;
		P3M1 &= ~SET_BIT0;	P3M2 |= SET_BIT0;	//P30_PUSHPULL_MODE;
		P5M1 &= ~SET_BIT2;	P5M2 |= SET_BIT2;	//P52_PUSHPULL_MODE;
		P5M1 &= ~SET_BIT3;	P5M2 |= SET_BIT3;	//P53_PUSHPULL_MODE;
		//========================================================
		EN_Buzzer_SetLow();
	//========================================================
	SFRS = 0x02;
		//==ADC_CHx===============================================
		P2MF32 &= 0x0F; P2MF32 |= 0x10; 		//MFP_P23_ADC_CH2;
		P2MF54 &= 0xF0; P2MF54 |= 0x01; 		//MFP_P24_ADC_CH1;
		P2MF54 &= 0x0F; P2MF54 |= 0x10; 		//MFP_P25_ADC_CH0;
	//========================================================
	SFRS = 0x00;
	//========================================================
}
//========================================================
// Function	  	: LCD_Initialize
// Function API : 
// param[in]	: None
// note			: None
// return		: None
// exmaple		: LCD_Initialize();
//========================================================
void LCD_Initialize(void)
{
	//========================================================
	Ht1621_Init();
	//========================================================
}
//========================================================
// Function	  	: ADC_Initialize
// Function API : 
// param[in]	: None
// note			: None
// return		: None
// exmaple		: ADC_Initialize();
//========================================================
void ADC_Initialize(void)
{
	//========================================================
	SFRS = 0x01;
		//==ADC acquisition time===================================
		//AINDIDS = 0xF8;	AIN2DIDS = 0;	AIN1DIDS = 0;	AIN0DIDS = 0;
		//MFP_P23_ADC_CH2	MFP_P24_ADC_CH1	MFP_P25_ADC_CH0
		//Disabled digital input at ADC channel 2/1/0.
		AINDIDS =		// ADC Channel Digital Input Disconnect			 
				(1<<7)|	//[7:0]	AINnDIDS: ADC Channel digital input disable
				(1<<6)|	//[7:0]	AINnDIDS: 0 = Enabled digital input at ADC channel n.
				(1<<5)|	//[7:0]	AINnDIDS: 1 = Disabled digital input at ADC channel n.
				(1<<4)|	//[7:0]	AINnDIDS: ADC channel n is read always 0.
				(1<<3)|	//[7:0]	AINnDIDS: 
				(0<<2)|	//[7:0]	AINnDIDS: 
				(0<<1)|	//[7:0]	AINnDIDS: 
				(0<<0);	//[7:0]	AINnDIDS: 
	//========================================================
	SFRS = 0x00;
		//==ADC acquisition time===================================
		//ADCSR		= 0x30;		FSYS = 24M;	FADC = FSYS/8 = 3M;	
		//ADCCON2	= 0x0E;		ADCAQT = 7;
		//ADC acquisition time = (4*ADCAQT+10)/FADC = (4*7+10)/3M  12.6666667us
		ADCSR =			// ADC Status Register			 
				(0<<7)|	//[7]	SLOW	: This bit is used to select ADC low speed.
						// 0 = high speed 500 ksps
						// 1 = low speed 200 ksps
				(1<<6)|	//[6:4]	ADCDIV	: ADC clock divider.
				(1<<5)|	// 000 = FADC is FSYS/1		001 = FADC is FSYS/2
				(1<<4)|	// 010 = FADC is FSYS/4		011 = FADC is FSYS/8	100 = FADC is FSYS/16
						// 101 = FADC is FSYS/32	110 = FADC is FSYS/64	111 = FADC is FSYS/128
				(0<<3)|	//[3]	-		:Reserved
				(0<<2)|	//[2]	CMPHIT	:ADC comparator Hit Flag
						// This bit is set by hardware when ADCMPO (ADCCON2.4) flag rising
						// Note: This bit can be cleared by writing 0 to it.
				(0<<1)|	//[1]	HDONE	:A/D Conversion Half Done Flag
						// This bit is set by hardware when half of ADCSN A/D conversions are complete in continuemode.
						// Note: This bit can be cleared by writing 0 to it
				(0<<0);	//[0]	FDONE	:A/D Conversion Full Done Flag
						// This bit is set by hardware when all of ADCSN A/D conversions are complete in continuemode or single conversion in single mode.
						// Note: This bit can be cleared by writing 0 to it..
						
		ADCCON2 =		// ADC Control 2			 
				(0<<7)|	//[7]	ADFBEN	: ADC compare result asserting Fault Brake enable
						// 0 = ADC asserting Fault Brake Disabled.
						// 1 = ADC asserting Fault Brake Enabled.
						// Fault Brake is asserted once its compare result ADCMPO is 1. Meanwhile, PWM channels output Fault Brake data. 
						// PWMRUN(PWMnCON0.7) will also be automatically cleared by hardware. The PWM output resumes when PWMRUN is set again.
				(0<<6)|	//[6]	ADCMPOP	: ADC comparator output polarity
						// 0 = ADCMPO is 1 if ADCR[11:0] is greater than or equal to ADCMP[11:0].
						// 1 = ADCMPO is 1 if ADCR[11:0] is less than ADCMP[11:0].
				(0<<5)|	//[5]	ADCMPEN	: ADC result comparator enable
						// 0 = ADC result comparator Disabled.
						// 1 = ADC result comparator Enabled.
				(0<<4)|	//[4]	ADCMPO	: ADC comparator output value
						// This bit is the output value of ADC result comparator based on the setting of ACMPOP. This bit updates after every A/D conversion complete.
				(1<<3)|	//[3:1]	ADCAQT	: ADC acquisition time
				(1<<2)|	// This 3-bit field decides the acquisition time for ADC sampling, following by equation below:
				(1<<1)| // ADC acquisition time = 4*ADCAQT+10/FADC
						// The default and minimum acquisition time is 10 ADC clock cycles.
						// Note: that this field should not be changed when ADC is in converting.
				(0<<0);	//[0]	ADCDLY.8: ADC external trigger delay counter bit 8. See ADCDLY register.
		//==Enabled ADC===========================================
		ADCCON1 =		// ADC Control 1			 
				(0<<7)|	//[7]	-		: Reserved
				(0<<6)|	//[6]	-		: Reserved
				(0<<5)|	//[5]	HIE		: ADC Half Done Interrupt Enable
						// 0 = ADC interrupt is not set while half of A/D conversions are complete in continue mode
						// 1 = ADC interrupt is set while half of A/D conversions are complete in continue mode
				(0<<4)|	//[4]	CONT	: ADC Continue Sampling select
						// 0 = ADC single sampling, ADC interrupt is set while an A/D conversion is completed
						// 1 = ADC continue sampling. ADC interrupt is set while total A/D conversions are completed
				(0<<3)|	//[3:2]	ETGTYP[1:0]	: External trigger type select
				(0<<2)|	// When ADCEX (ADCCON1.1) is set, these bits select which condition triggers ADC conversion.
						// 00 = Falling edge on PWM0/2/4 or STADC pin.
						// 01 = Rising edge on PWM0/2/4 or STADC pin.
						// 10 = Central point of a PWM period.
						// 11 = End point of a PWM period.
						// Note: that the central point interrupt or the period point interrupt is only available for PWM center-aligned type.
				(0<<1)| //[1]	ADCEX	: ADC external conversion trigger select
						// This bit to select the methods of triggering an A/D conversion.
						// 0 = A/D conversion is started only via setting ADCS bit.
						// 1 = A/D conversion is started via setting ADCS bit or by external trigger source depending on ETGSEL[1:0] and ETGTYP[1:0].
						// Note: that while ADCS is 1 (busy in converting), the ADC will ignore the following external trigger until ADCS is hardware cleared.
				(1<<0);	//[0]	ADCEN	: ADC enable
						// 0 = ADC circuit off.
						// 1 = ADC circuit on.
	//========================================================
}
//========================================================
// Function	  	: WDT_Initialize
// Function API : 
// param[in]	: None
// note			: None
// return		: None
// exmaple		: WDT_Initialize();
//========================================================
void WDT_Initialize(void)
{
	//========================================================
/*	SFRS = 0x00;
	//========================================================
    TA = 0xAA;	TA = 0x55;	WDCON &= 0xF8;
	TA = 0xAA;	TA = 0x55;	WDCON |= 0x07;
    TA = 0xAA;	TA = 0x55;	WDCON |= SET_BIT4;	//set_WDCON_WIDPD;
    TA = 0xAA;	TA = 0x55;	WDCON |= SET_BIT7;	//set_WDCON_WDTR;
	
	EIE0 &= CLR_BIT4;//clr_EIE0_EWDT;
	
//	WDT_Reset(Enable);
	set_CHPCON_IAPEN;
	set_IAPUEN_CFUEN;
	IAPAL = 0x04;
	IAPAH = 0x00;  
	IAPCN = BYTE_PROGRAM_CONFIG;            //Read config command
	IAPFD = 0x0F;
	set_IAPTRG_IAPGO;  
	clr_IAPUEN_CFUEN;
	clr_CHPCON_IAPEN;*/
	//========================================================
}
//========================================================
// Function	  	: Timer_Initialize
// Function API : 
// param[in]	: None
// note			: None
// return		: None
// exmaple		: Timer_Initialize();
//========================================================
void Timer_Initialize(void)
{
	//========================================================
	SFRS = 0x00;
	//========================================================
    TMOD &= 0x0F;	TMOD |= 0x10;	//ENABLE_TIMER1_MODE1;	Timer 0 mode configuration
	CKCON|= SET_BIT4;	//set_CKCON_T1M;	TIMER1_FSYS			1/1Ƶ
//	CKCON&= CLR_BIT4;	//clr_CKCON_T1M;	TIMER1_FSYS_DIV12	1/12Ƶ
    TH1 = TH1_INIT;
    TL1 = TL1_INIT;
	TCON |= SET_BIT6;	//set_TCON_TR1;
	//========================================================
	IE |= SET_BIT3;		//set_IE_ET1;
	//========================================================
	EA = 1;				//ENABLE_GLOBAL_INTERRUPT;
	//========================================================
}
//========================================================
// Function	  	: SYSTEM_Initialize
// Function API : 
// param[in]	: None
// note			: None
// return		: None
// exmaple		: SYSTEM_Initialize();
//========================================================
void SYSTEM_Initialize(void)
{
	//========================================================
	OSCILLATOR_Initialize();
	PIN_Initialize();
	LCD_Initialize();
	ADC_Initialize();
//	WDT_Initialize();
	Timer_Initialize();
	//========================================================
//	Hardware_Init();
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
// Function 	: Timer0_Delay
// Function API : Timer0 delay setting
// param[in]	: 
// u32SYSCLK	: define Fsys clock value. for example 24000000, use the real Fsys value.
//					- \ref 24000000 (use HIRC)
//					- \ref 22118400 (use HXT)
// u16CNT		: define count time.
// u16DLYUnit	: define delay time base is us. From 1~10000, the maxima value please not over 10000.
//					- \ref 1000 (1ms)
//					- \ref 100 (100us)
// note			: If use LIRC or LXT as Fsys need adjust this marco.
// return		: None
// exmaple		: Timer0_Delay(24000000,10,1000);
//======================================================== 
void Timer0_Delay(		unsigned long	u32SYSCLK,
						unsigned int	u16CNT,
						unsigned int	u16DLYUnit)
{
	//========================================================
	SFRS = 0x00;
	//========================================================
	CKCON&= CLR_BIT3;		//clr_CKCON_T0M;	//T0M=0, Timer0 Clock = Fsys/12
	TMOD |= 0x01;			//Timer0 is 16-bit mode
	//========================================================
	while(u16CNT != 0)
	{
		//========================================================
		TL0 = (unsigned char)((65536-(u16DLYUnit/1*(u32SYSCLK/1000000)))>>8);
		TH0 = (unsigned char)((65536-(u16DLYUnit/1*(u32SYSCLK/1000000)))&0xFF);
		//========================================================
		TCON |= SET_BIT4;	//set_TCON_TR0;		//Start Timer0
		while (TF0 != 1);	//Check Timer0 Time-Out Flag
		TCON &= CLR_BIT5;	//clr_TCON_TF0;
		//========================================================
		u16CNT--;
		//========================================================
	}
	//========================================================
	TCON &= CLR_BIT4;		//clr_TCON_TR0;		//Stop Timer0
	//========================================================
}
//========================================================
#endif
//========================================================
// Function	 	: 
// Function API	: 
// return		: None
//========================================================
