//========================================================
// File		: main.c
// Author	: wzh
// Version	: V1.0
// Date		: 20.09.29
//========================================================
#define GLOBAL_DEVICE			//GLOBALS, ʾеȫֱڱļж
//========================================================
// Section: Included Files
//========================================================
#include "main.h"
#include "Library/Device/Include/ML51.h"
//========================================================
// Section: Macro Declarations
//========================================================

//========================================================
#if		1
//========================================================
// Function		: 
// Function API	: 
//========================================================
void Main_Init(void)
{
	//========================================================
	// Device Init
	//========================================================
		ucTimeCount_Base = 0;
		ucTimeBase_256ms = 0;
		SmokeMode_Fault_ns = 0;
		SmokeMode_Alarm_6s = 0;
		Smoke_Alarm_Disable = 0;
		ReadSmokeMessage_12s = 2;
		//========================================================
		Device_Duty = 0;
		bDevice_Key_Idle = 1;	// ȥ_δ
		bDevice_KeyAlarm_Done = 1;
		Warning_Event = WAENING_EVENT_INIT;
	//========================================================
	// Voice_NSP080A Init
	//========================================================
		VOICE_API_Init;
		Voice_Clear_Event(&stVoice_Queue);
	//========================================================
	// Device Communication Init
	//========================================================
		DEVCOM_API_Init;
	//========================================================
	// Smoke Mode Init
	//========================================================
		SMODE_API_Init;
	//========================================================
}
//========================================================
// Function		: 
// Function API	: 
//========================================================
void Warning_Handler(void)
{
	//========================================================
	switch( Warning_Event )
	{
		//========================================================
		case WAENING_EVENT_INIT:
			//========================================================
			LED_PIN_RED = 0;
			LED_PIN_GREEN = 0;
			//========================================================
			Warning_Event++;
			ucWarning_TimeCount = ucTimeBase_256ms;
			//========================================================
			break;
			//========================================================
		case WAENING_EVENT_INIT+1:
			//========================================================
			if( (unsigned char)(ucTimeBase_256ms-ucWarning_TimeCount)>=2 )
			{
				//========================================================
				LED_PIN_RED = 1;
				LED_PIN_GREEN = 1;
				//========================================================
				Warning_Event = WAENING_EVENT_IDLE;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case WAENING_EVENT_IDLE:
			//========================================================
			if( ((SMODE_API_Alarm)||(SMODE_PIN_ALARM && SMODE_API_ModeInit_Done))&&
				(SmokeMode_Alarm_6s==0)&&(Smoke_Alarm_Disable==0) )
			{
				//========================================================
				LED_PIN_RED = 0;
				LED_PIN_GREEN = 1;
				//========================================================
				SmokeMode_Alarm_6s = 1;		// 1*6=6S
				bDevice_Warning_Idle = 0;
				ucWarning_TimeCount = ucTimeBase_256ms;
				Warning_Event = WAENING_EVENT_LED_AUTO_BLINK;
				//========================================================
				Play_The_Voice(4);			// 鱨_:di---- 		1S
				Play_The_Voice(5);			// 鱨_:ַ 1.76S
				//========================================================
			}
			else if( bDevice_KeyAlarm_Done==0 )
			{
				//========================================================
				bDevice_KeyAlarm_Done = 1;
				//========================================================
				if( (SMODE_API_Alarm)||(SMODE_PIN_ALARM) )
					Smoke_Alarm_Disable = 15;	// 15*6=90S
				else if( (SMODE_API_ModeInit_Done)&&(SMODE_API_Init_Exception) )
				{	// HTK5020ģϵʼ쳣,ɰԼ찴
					// дHTK5020ģ״̬¼,Ӷ³ʼ
					//========================================================
					SMODE_API_ModeInit_Done = 0;
					SMODE_API_Init_Exception = 0;
					SMODE_API_WriteStatusEvent_Done = 0;
					//========================================================
				}
				else
				{
					//========================================================
					LED_PIN_RED = 0;
					LED_PIN_GREEN = 1;
					//========================================================
					bDevice_Warning_Idle = 0;
					ucWarning_TimeCount = ucTimeBase_256ms;
					Warning_Event = WAENING_EVENT_LED_AUTO_BLINK;
					//========================================================
					Play_The_Voice(4);		// Լ_:di---- 		1S
					Play_The_Voice(5);		// Լ_:ַ 1.76S
					//========================================================
				}
				//========================================================
			}
			else if( (SMODE_API_ModeInit_Done==0) )
			{
				//========================================================
				if( (SMODE_API_Init_Complete)||(SMODE_PIN_INIT==0) )
				{
					//========================================================
					LED_PIN_RED = 1;
					LED_PIN_GREEN = 0;
					//========================================================
					SMODE_API_ModeInit_Done = 1;
					//========================================================
					bDevice_Warning_Idle = 0;
					ucWarning_TimeCount = ucTimeBase_256ms;
					Warning_Event = WAENING_EVENT_LED_AUTO_BLINK;
					//========================================================
					Play_The_Voice(25);		// ʼ_:̽ʼ
					//========================================================
				}
				else if( SMODE_API_Init_Exception )
				{
					//========================================================
					LED_PIN_RED = 0;
					LED_PIN_GREEN = 1;
					//========================================================
					SMODE_API_ModeInit_Done = 1;
					//========================================================
					bDevice_Warning_Idle = 0;
					ucWarning_TimeCount = ucTimeBase_256ms;
					Warning_Event = WAENING_EVENT_LED_AUTO_BLINK;
					//========================================================
					Play_The_Voice(3);		// ʼ쳣_:ε
					//========================================================
				}
				//========================================================
			}
			else if(	((SMODE_API_Adpd_Commu_Exception)||(SMODE_API_Fault))&&
						(SmokeMode_Fault_ns==0) )
			{
				//========================================================
				LED_PIN_RED = 0;
				LED_PIN_GREEN = 1;
				//========================================================
				SmokeMode_Fault_ns = 10;	// 10*6=60S	ÿ60Sһ
				bDevice_Warning_Idle = 0;
				ucWarning_TimeCount = ucTimeBase_256ms;
				Warning_Event = WAENING_EVENT_LED_AUTO_BLINK;
				//========================================================
				Play_The_Voice(7);			// HTK5020ģ_:̽
				//========================================================
			}
			else
				bDevice_Warning_Idle = 1;
			//========================================================
			break;
			//========================================================
		case WAENING_EVENT_LED_AUTO_BLINK:
			//========================================================
			if( (unsigned char)(ucTimeBase_256ms-ucWarning_TimeCount)>=2 )
			{
				//========================================================
				Warning_Event = WAENING_EVENT_LED_OFF;
				ucWarning_TimeCount = ucTimeBase_256ms;
				//========================================================
			}
			//========================================================
			break;
			//========================================================
		case WAENING_EVENT_LED_OFF:
			//========================================================
			LED_PIN_RED = 1;
			LED_PIN_GREEN = 1;
			//========================================================
			if( (unsigned char)(ucTimeBase_256ms-ucWarning_TimeCount)>=2 )
				Warning_Event = WAENING_EVENT_IDLE;
			//========================================================
			break;
			//========================================================
		default:
			//========================================================
			Warning_Event = WAENING_EVENT_IDLE;
			//========================================================
			break;
			//========================================================
		//========================================================
	}
	//========================================================
}
//========================================================
#endif
//========================================================
#if		1
//========================================================
// Function 	: Main application
// Function API : 
//========================================================
void main(void)
{
	//========================================================
	Hardware_Init();
	//========================================================
	Main_Init();
	//========================================================
	Play_The_Voice(1);
	Play_The_Voice(9);
	Play_The_Voice(37);	// haoshenqi=37
	Play_The_Voice(10);
	//========================================================
    while(1)
    {
		//========================================================
		Voice_Handler();
		Warning_Handler();
		DeviceCommu_Handler();
		SmokeMode_Handler();
		SmokeMode_Uart_Handler();
		//========================================================
		Clear_WDT_Timer();
		//========================================================
		if( (SMODE_API_HTK5020_Duty==0xFF)&&(Device_Duty==0x1F) )
			Enter_Deep_Sleep();
		//========================================================
	}
	//========================================================
}
//========================================================
#endif
//========================================================
// Function 	: 
// Function API : 
//========================================================

//========================================================
// Section: End Of file
//========================================================
