//==============================================================
// File		: main.h
// Author	: wzh
// Version	: V1.0
// Date		: 20.09.29
//==============================================================

//Define to prevent recursive inclusion=========================
#ifndef main_H
#define	main_H
//==============================================================
// Section: Included Files
//==============================================================
#include "Hardware/Hardware.h"
#include "App_Handler/Voice.h"
#include "App_Handler/SmokeMode.h"
#include "App_Handler/DeviceCommu.h"
//==============================================================
#ifdef GLOBAL_DEVICE
    #define EXTERN_DEVICE
#else
    #define EXTERN_DEVICE extern
#endif
//==============================================================
// Section: Exported Constants
//==============================================================

//==WAENING_EVENT===============================================
#define	WAENING_EVENT_INIT				0
#define	WAENING_EVENT_IDLE				5
#define	WAENING_EVENT_LED_AUTO_BLINK	10
#define	WAENING_EVENT_LED_OFF			15
//==============================================================
// Section: Exported Variables
//==============================================================
EXTERN_DEVICE unsigned		char	bdata	Device_Duty;
EXTERN_DEVICE unsigned		char	data	SmokeMode_Fault_ns;
EXTERN_DEVICE unsigned		char	data	SmokeMode_Alarm_6s;
EXTERN_DEVICE unsigned		char	data	Smoke_Alarm_Disable;
EXTERN_DEVICE unsigned		char	data	ReadSmokeMessage_12s;
EXTERN_DEVICE unsigned		char	data	Warning_Event;
EXTERN_DEVICE volatile	unsigned	char	data	ucTimeCount_Base;	// Time Count Base_1ms
EXTERN_DEVICE volatile	unsigned	char	data	ucTimeBase_256ms;	// Time Count Base_256ms
EXTERN_DEVICE volatile	unsigned	char	data	ucWarning_TimeCount;
//==============================================================
#ifdef	GLOBAL_DEVICE
	//==Device_Duty=================================================
	sbit bDevice_Key_Idle		= Device_Duty^0;
	sbit bDevice_Voice_Idle		= Device_Duty^1;
	sbit bDevice_Commu_Idle		= Device_Duty^2;
	sbit bDevice_Warning_Idle	= Device_Duty^3;
	sbit bDevice_KeyAlarm_Done	= Device_Duty^4;
	//==============================================================
#else
	//==Device_Duty=================================================
	extern	bit bDevice_Key_Idle,bDevice_Voice_Idle;
	extern	bit bDevice_Commu_Idle,bDevice_Warning_Idle;
	extern	bit bDevice_KeyAlarm_Done;
	//==============================================================
#endif	//#ifdef GLOBAL_DEVICE
//==============================================================
// Section: Exported Functions
//==============================================================

//==============================================================
// Section: End Of file
//==============================================================
#endif
